<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class api extends CI_Controller {


	public function __construct()
	{
		parent::__construct();
                // Your own constructor code
		$this->load->database();
	}
	private function getCurrentTime(){
		$date = new DateTime();
		return $date->getTimestamp();
	}
	private function getBaseResponseModel()
	{
		return array('response' => '','responseCode'=>200);
	}
	private function unSetHashValues($arr){
		if(isset($arr) && is_array($arr) && count($arr)>0 ){
            foreach ($arr as $row) {
                if(isset($row->user_first_name)) {
                    $row->user_first_name = base64_url_encode($row->user_first_name);
                }
                if (isset($row->user_last_name)) {
                    $row->user_last_name = base64_url_encode($row->user_last_name);
                }
                if (isset($row->patient_ref_no)) {
                    $row->patient_ref_no = base64_url_encode($row->patient_ref_no);
                }
                if (isset($row->date_of_birth)) {
                    $row->date_of_birth = base64_url_encode($row->date_of_birth);
                }
                if (isset($row->phone_number)) {
                    $row->phone_number = base64_url_encode($row->phone_number);
                }
               
                if (isset($row->email)) {
                    $row->email = base64_url_encode($row->email);
                }
                if (isset($row->phone_number)) {
                    $row->phone_number = base64_url_encode($row->phone_number);
                }
                if (isset($row->password)) {
                    $row->password = base64_url_encode($row->password);
                }
            }
        }
        return $arr;
	}
	private function checkHashValue($arr){
        if(isset($arr) && is_array($arr) && count($arr)>0 ){
            foreach ($arr as $row) {
                
                if(isset($row->user_first_name)) {
                    $row->user_first_name = ucfirst(preg_replace('/\s+/', '', base64_url_decode($row->user_first_name)));
                }
                if (isset($row->user_last_name)) {
                    $row->user_last_name = ucfirst(preg_replace('/\s+/', '', base64_url_decode($row->user_last_name)));
                }
                if (isset($row->patient_ref_no)) {
                    $row->patient_ref_no = base64_url_decode($row->patient_ref_no);
                }
                if (isset($row->date_of_birth)) {
                    $row->date_of_birth = base64_url_decode($row->date_of_birth);
                }
                if (isset($row->phone_number)) {
                    $row->phone_number = base64_url_decode($row->phone_number);
                }
                if (isset($row->email)) {
                    $row->email = base64_url_decode($row->email);
                }
                if (isset($row->password)) {
                    $row->password = base64_url_decode($row->password);
                }
            }
        }
        return $arr;
    }
	private function checkBasicRequirementOfApi($apiCallType,$requiredParamList,&$jsonObject){
		$response =  $this->getBaseResponseModel();

		if($this->input->server('REQUEST_METHOD') == Strtoupper ($apiCallType)){
				//Check Response not empty
			if(file_get_contents('php://input') != ''){
					//Parse JSON
				$jsonArray = json_decode(file_get_contents('php://input'),true);
					//Check error while parsing json
				if($jsonArray != null && json_last_error() == JSON_ERROR_NONE){
						//Check required key present in json
					if(count(array_intersect_key(array_flip($requiredParamList), $jsonArray)) === count($requiredParamList)) {
							//return json
						if (!in_array('token', $requiredParamList)){
							$jsonObject = $jsonArray;
						}else{
							if($this->isTokenValid($jsonArray['token'])){
								$jsonObject = $jsonArray;
							}else{
								$response['response'] = "token not valid.";
								$response['responseCode'] = 204;
							}
						}
					}else{
						$response['response'] = "parameters missing.";
						$response['responseCode'] = 204;
					}
				}else{
					$response['response'] = "request not valid json.";
					$response['responseCode'] = 203;
				}
			}else{
				$response['response'] = "request can't be empty.";
				$response['responseCode'] = 202;
			}
		}else{
			$response['response'] = "method must be ".$apiCallType;
			$response['responseCode'] = 201;
		}
		return $response;
	}
	private function getUserPropertiesByToken($token){
		$tokenDecoded = base64_decode($token);
		$tokenDecoded = explode('|', $tokenDecoded);
		return (array('userId' => $tokenDecoded[0],'email'=> $tokenDecoded[1]));
	}
	private function isTokenValid($token){
		$tokenDecoded = base64_decode($token);
		$tokenDecoded = explode('|', $tokenDecoded);
		if(count($tokenDecoded) == 2){
			$query = $this->db->get_where('user_info',array('id' => $tokenDecoded[0]));
			return count($query->result()) > 0;
		}else{
			echo $tokenDecoded[0];
			return false;
		}
	}
	public function login()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('email','password'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user by email or phone.
				$this->db->or_where('email',$jsonObject['email']);
				$this->db->or_where('phone_number',$jsonObject['email']);
			$query = $this->db->get('user_info');
			
				//check user against email exsist.
			if(count($query->result()) > 0){
				foreach ($query->result() as $row)
				{
						//check retry count and last login retry threshold.
				//	if($row->retryCount < 3 || strtotime("-1 hour") > $row//->last_login_try_time) {
							// check password.
					//	if($row->password == $jsonObject['password']){
							$returnResponse = array();
							$row->retryCount = 0;
							$this->db->where('id',$row->id);
							$this->db->update('user_info', $row);
							$queryHabit = $this->db->get_where('habit',array('user_id'=>$row->id));
							$habits = array();
							foreach ($queryHabit->result() as $rowHabit)
							{
								unset($rowHabit->id);
								array_push($habits, $rowHabit);
							}
							$queryGoal = $this->db->get_where('goal',array('user_id'=>$row->id));
							$goals = array();
							foreach ($queryGoal->result() as $rowGoal)
							{
								unset($rowGoal->id);
								array_push($goals, $rowGoal);
							}
							unset($row->id);
							$returnResponse['user'] = $this->checkHashValue($row);
							$returnResponse['goals'] = $goals;
							$returnResponse['habits'] = $habits;
							$response['response'] = $returnResponse;
					//	}else{
					//		$response['response'] = "Email or Password do not match.";
					//		$response['responseCode'] = 400;
					//		$row->retryCount++;
					//		$row->last_login_try_time = strtotime("now");
					//		$this->db->where('id',$row->id);
					//		$this->db->update('user_info', $row);
					//	}
					//}else{
					//	$response['response'] = "You can retry after one hour.";
					//	$response['responseCode'] = 400;
					//}
					break;
				}
			}else{
				$response['response'] = "Email or Password not match.";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function registerWithEmail()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('email'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user by email.

			$this->db->or_where('email',$jsonObject['email']);
				$this->db->or_where('phone_number',$jsonObject['email']);
			$query = $this->db->get('user_info');
				//check user against email exsist.
			if(count($query->result()) > 0){
				foreach ($query->result() as $row)
				{
					$response['response'] = json_decode(json_encode($this->checkHashValue($row)));
					$row->is_registered = 1;
					$this->db->where('id',$row->id);
					$this->db->update('user_info', $row);
					break;
				}
			}else{
				$response['response'] = "This username does not exist in the system";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function updatePassword()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','newPassword'),$jsonObject);
		if($response['responseCode'] == 200){
			$query = $this->db->get_where('user_info',array('email'=>$userProperties['email']));
				//check user against email exsist.
			if(count($query->result()) > 0){
				foreach ($query->result() as $row)
				{
					$row->password = $jsonObject['newPassword'];
					$this->db->update('user_info', $row);
					$response['response'] = $row;
					break;
				}
			}else{
				$response['response'] = "User not in system.";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function requestForAppoitment(){
	    $jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
				$query = $this->db->get_where('appoitment_request',array('user_id'=>$userProperties['userId']));
				//check user against email exsist.
			if(count($query->result()) == 0){
				$this->db->insert('appoitment_request', array('user_id'=>$userProperties['userId']));
			}
		    
		}
		$this->output->set_output(json_encode($response));
	} 
	public function setFirstTimePassword()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('email','newPassword'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$query = $this->db->get_where('user_info',array('email'=>$jsonObject['email']));
				//check user against email exsist.
			if(count($query->result()) > 0){
				foreach ($query->result() as $row)
				{
					$row->password = $jsonObject['newPassword'];
					$this->db->where('id',$row->id);
					$this->db->update('user_info', $row);
					$response['response'] = $row;
					break;
				}
			}else{
				$response['response'] = "User not in system.";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function updateUserProfileInfo()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','user_first_name','user_last_name','date_of_birth','gender'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$query = $this->db->get_where('user_info',array('id'=>$userProperties['userId']));
				//check user against email exsist.
			if(count($query->result()) > 0){
				foreach ($query->result() as $row)
				{
					$row->user_first_name = $jsonObject['user_first_name'];
					$row->user_last_name = $jsonObject['user_last_name'];
					$row->date_of_birth = $jsonObject['date_of_birth'];
					$row->gender = $jsonObject['gender'];
					$this->db->where('id',$row->id);
					$this->db->update('user_info', $row);
					$response['response'] = $row;
					break;
				}
			}else{
				$response['response'] = "User not in system.";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function updateOrAddHabit()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','habits'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			if(count($jsonObject['habits']) > 0){
				$habitList = array();
				for($i=0; $i<count($jsonObject['habits']); $i++)
				{
					$habit = $jsonObject['habits'][$i];
					$habit['habit_data'] = json_encode($habit['habit_data']);
					$habit['user_id'] = $userProperties['userId'];
					$this->db->replace('habit', $habit);
					$habit['id'] = $this->db->insert_id();
					array_push($habitList, $habit);
				}
				$response['response'] = $habitList;
			}else{
				$response['response'] = "Habit list empty.";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function updateHeight()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','height'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$query = $this->db->get_where('user_info',array('id'=>$userProperties['userId']));
				//check user against email exsist.
			if(count($query->result()) > 0){
				foreach ($query->result() as $row)
				{
					$row->current_height = $jsonObject['height'];
					$this->db->update('user_info', $row);
					$response['response'] = $row;
					break;
				}
			}else{
				$response['response'] = "User not in system.";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function updateHeightAndWeight()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','height','weight'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$query = $this->db->get_where('user_info',array('id'=>$userProperties['userId']));
				//check user against email exsist.
			if(count($query->result()) > 0){
				foreach ($query->result() as $row)
				{
					$row->current_height = $jsonObject['height'];
					$row->current_weight = $jsonObject['weight'];
					$this->db->where('id',$row->id);
					$this->db->update('user_info', $row);
					$this->db->delete('weight_assessment', array('user_id'=>$userProperties['userId']));
					$this->db->insert('weight_assessment', array('user_id'=>$userProperties['userId'],'weight'=>$jsonObject['weight'],'entered_at'=> time ()));
					$weigthAssesment = $this->db->get_where('weight_assessment',array('id'=>$this->db->insert_id()))->row();
					$response['response'] = array('user'=>$row,'weight_assessment'=>$weigthAssesment);
					break;
				}
			}else{
				$response['response'] = "User not in system.";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function updateWeight()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','weight'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$query = $this->db->get_where('user_info',array('id'=>$userProperties['userId']));
			$now = new DateTime('now');
				//check user against email exsist.
			if(count($query->result()) > 0){
				foreach ($query->result() as $row)
				{
					$getUserWeightsQry = " SELECT weight_assessment.* FROM weight_assessment WHERE user_id =  " . $userProperties['userId'] . " ORDER BY id ASC LIMIT 1 ";
					$getUserWeightsRes = $this->db->query($getUserWeightsQry);
					$userWeights = $getUserWeightsRes->result_array();
					
					if( count($userWeights) == 0  )
					{
						$row->current_weight = $jsonObject['weight'];
					}
					else
					{
						$initialWeight = ( isset($userWeights[0]["weight"]) && !empty($userWeights[0]["weight"]) ? $userWeights[0]["weight"] : "0" );
						$row->current_weight = $initialWeight;
					}
					
					$this->db->where('id',$row->id);
					$this->db->update('user_info', $row);
					$timestamp = $jsonObject['created_at'];
					
					$beginOfDay = DateTime::createFromFormat('Y-m-d H:i:s', (new DateTime())->setTimestamp($timestamp)->format('Y-m-d 00:00:00'))->getTimestamp();
                    $endOfDay = DateTime::createFromFormat('Y-m-d H:i:s', (new DateTime())->setTimestamp($timestamp)->format('Y-m-d 23:59:59'))->getTimestamp();
                    $this->db->where(array('user_id'=>$userProperties['userId'],'entered_at <'=>$endOfDay,'entered_at >'=>$beginOfDay));
                    $this->db->delete('weight_assessment');
					
					$this->db->insert('weight_assessment', array('user_id'=>$userProperties['userId'],'weight'=>$jsonObject['weight'],'entered_at'=> $jsonObject['created_at']));
					$response['response'] = array('user'=>$row,'weight_assessment'=>$this->db->get_where('weight_assessment',array('id'=>$this->db->insert_id()))->row());
					break;
				}
			}else{
				$response['response'] = "User not in system.";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function getLastWeight()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token'),$jsonObject);
		if($response['responseCode'] == 200){
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$response['response'] = $this->getLastWeightInternal($userProperties['userId']);
		}
		$this->output->set_output(json_encode($response));
	}
	private function resetAppoitmentCountOfPatient(){
	    $jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token'),$jsonObject);
		if($response['responseCode'] == 200){
		    $userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
		    $this->db->set('readValue',1);
	   $this->db->where(array('patient_id'=>$userProperties['userId'],'readValue' => 0));
	   $this->db->update('appointment');
			
		}
	}
	private function getAppoitmentCountOfPatient()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$appointmentList = array();
			$count = $this->db->where(array('patient_id'=>$userProperties['userId'],'readValue'=>0))->from('appointment')->count_all_results();
			$this->resetAppoitmentCountOfPatient();
			return $count;
			
		}
		return 0;
	}
	public function getDashBoardData(){
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token'),$jsonObject);
		if($response['responseCode'] == 200){
			$reposneData = array();
			$todayDate =  new DateTime();
			$month = (int)$todayDate->format("m");
			$year = (int)$todayDate->format("Y");
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$reposneData['messageCount'] = $this->getInboxUnreadCount();
			$reposneData['appointmentCount'] = $this->getAppoitmentCountOfPatient();
			$reposneData['weigth'] = $this->getGraphValueForWeigth($userProperties['userId'],$month,$year);
			$reposneData['diet'] = $this->getGraphValueForDiet($userProperties['userId'],$month,$year);
			$reposneData['excercise'] = $this->getGraphValueForExcercise($userProperties['userId'],$month,$year);
			//$reposneData['sugarLevel'] = $this->getGraphValueForBloodSugar($userProperties['userId']);
			$response['response'] = $reposneData;
		}
		$this->output->set_output(json_encode($response));
	}
	public function getMonthlyReportData(){
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','month','year'),$jsonObject);
		if($response['responseCode'] == 200){
			$reposneData = array();
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$reposneData['excerciseGraphData'] = $this->getExcerciseListForGraphInternal($userProperties['userId'],$jsonObject['month'],$jsonObject['year']);
			$reposneData['dietGraphData'] = $this->getDietListForGraphInternal($userProperties['userId'],$jsonObject['month'],$jsonObject['year']);
			$reposneData['weigthGraphData'] = $this->getWeigthListForGraphInternal($userProperties['userId'],$jsonObject['month'],$jsonObject['year']);
			$reposneData['weigthGuageData'] = $this->getGraphValueForWeigth($userProperties['userId'],$jsonObject['month'],$jsonObject['year']);
			$reposneData['dietGuageData'] = $this->getGraphValueForDiet($userProperties['userId'],$jsonObject['month'],$jsonObject['year']);
			$reposneData['excerciseGuageData'] = $this->getGraphValueForExcercise($userProperties['userId'],$jsonObject['month'],$jsonObject['year']);
			//$reposneData['sugarLevel'] = $this->getGraphValueForBloodSugar($userProperties['userId']);
			$response['response'] = $reposneData;
		}
		$this->output->set_output(json_encode($response));
	}
	private function getGraphValueForExcercise($userId,$month,$year){
			//goal_type:2
			$goalValue = $this->getGoalByTypeInternal($userId,2);
			$monthExcerciseValue = $this->getExcerciseListForGraphInternal($userId,$month,$year);
			$monthExcerciseValue  = array_filter($monthExcerciseValue , function($value) { return $value !== null; });
			$recordedValues = count($monthExcerciseValue);
			if($recordedValues  === 0){
				return 0;
			}else{
				return (array_sum($monthExcerciseValue)/($goalValue*3600*$recordedValues))*100;
			}
	}
	private function getExcerciseListForGraphInternal($userId,$month,$year){
		$format = 'Y-m-d';
		$oFirst = DateTime::createFromFormat($format, $year.'-'.($month).'-1');
		$oLast  = DateTime::createFromFormat($format, $year.'-'.$month.'-'.cal_days_in_month(CAL_GREGORIAN, $month, $year));
		$oLast->setTime(23, 59, 59);
		$yearDifference = (int)date("Y") - $year;
		if($yearDifference != 0){
			$oFirst->modify('-'.$yearDifference.' year');
			$oLast->modify('-'.$yearDifference.' year');
		}
		$oFirstTimeStamp = $oFirst->getTimestamp();
		$oLastTimeStamp = $oLast->getTimestamp();
		$query = $this->db->where(array('created_at < '=>$oLastTimeStamp,'created_at > '=>$oFirstTimeStamp,'user_id'=>$userId))->order_by('created_at','ASC')->get('excercise_assessment');
		$excerciseAssesmentList = array();
		$numberOfDaysInMonth = cal_days_in_month(CAL_GREGORIAN, $month, $year);
		$array_index = 0;
		$array_excericse_list = array();
		foreach($query->result() as $row)
		{
			array_push($array_excericse_list, $row);
		}
		for($i=0; $i<=$numberOfDaysInMonth; $i++)
		{
			$timeStartOfDay = $oFirst->getTimestamp();
			$oFirst->modify('+1 day');
			$timeOfDayEnd = $oFirst->getTimestamp();
			if($array_index < count($array_excericse_list)){
				if($array_excericse_list[$array_index]->created_at < $timeOfDayEnd && $array_excericse_list[$array_index]->created_at > $timeStartOfDay){
					$sumOfExcerciseTimeOfOneDay = 0;
					while( $array_index < count($array_excericse_list) && $array_excericse_list[$array_index]->created_at < $timeOfDayEnd && $array_excericse_list[$array_index]->created_at > $timeStartOfDay){
						$sumOfExcerciseTimeOfOneDay += (int)$array_excericse_list[$array_index]->duration;
						$array_index++;
					}
					array_push($excerciseAssesmentList, $sumOfExcerciseTimeOfOneDay);
				}else{
					array_push($excerciseAssesmentList, null);
				}
			}else{
				array_push($excerciseAssesmentList, null);
			}
		}
		return $excerciseAssesmentList;
	}
	private function getGraphValueForBloodSugar($userId){
			$response = array();
			$todayDate =  new DateTime();
			$month = (int)$todayDate->format("m");
			$year = (int)$todayDate->format("Y");
			$monthDietValue = $this->getBloodSugarListForGraphInternal($userId,$month,$year);
			$response['value'] = $monthDietValue;
			return $response;
	}
	private function getBloodSugarListForGraphInternal($userId,$month,$year){
		$format = 'Y-m-d';
		$oFirst = DateTime::createFromFormat($format, $year.'-'.($month).'-1');
		$oLast  = DateTime::createFromFormat($format, $year.'-'.$month.'-'.cal_days_in_month(CAL_GREGORIAN, $month, $year));
		$oLast->setTime(23, 59, 59);
		$yearDifference = (int)date("Y") - $year;
		if($yearDifference != 0){
			$oFirst->modify('-'.$yearDifference.' year');
			$oLast->modify('-'.$yearDifference.' year');
		}
		$oFirstTimeStamp = $oFirst->getTimestamp();
		$oLastTimeStamp = $oLast->getTimestamp();
		$query = $this->db->where(array('created_at < '=>$oLastTimeStamp,'created_at > '=>$oFirstTimeStamp,'user_id'=>$userId))->order_by('created_at','ASC')->get('blood_sugar_assessment');
		$bloodSugarAssesmentList = array();
		$numberOfDaysInMonth = cal_days_in_month(CAL_GREGORIAN, $month, $year);
		$array_index = 0;
		$array_blood_sugar_list = array();
		foreach($query->result() as $row)
		{
			array_push($array_blood_sugar_list, $row);
		}
		for($i=0; $i<=$numberOfDaysInMonth; $i++)
		{
			$timeStartOfDay = $oFirst->getTimestamp();
			$oFirst->modify('+1 day');
			$timeOfDayEnd = $oFirst->getTimestamp();
			if($array_index < count($array_blood_sugar_list)){
				if($array_blood_sugar_list[$array_index]->created_at < $timeOfDayEnd && $array_blood_sugar_list[$array_index]->created_at > $timeStartOfDay){
					$sumOfSugarLevelsOfOneDay = 0;
					$testInOneDay = 0;
					while( $array_index < count($array_blood_sugar_list) && $array_blood_sugar_list[$array_index]->created_at < $timeOfDayEnd && $array_blood_sugar_list[$array_index]->created_at > $timeStartOfDay){
						$sumOfSugarLevelsOfOneDay += (int)$array_blood_sugar_list[$array_index]->sugar_level;
						$array_index++;
						$testInOneDay++;
					}
					array_push($bloodSugarAssesmentList, $sumOfCaloriesOfOneDay/$testInOneDay);
				}else{
					//array_push($dietAssesmentList, null);
				}
			}else{
				//array_push($dietAssesmentList, null);
			}
		}
		return $bloodSugarAssesmentList;
	}
	private function getGraphValueForDiet($userId,$month,$year){
			//goal_type:3
			$goalValue = $this->getGoalByTypeInternal($userId,3);
			$monthDietValue = $this->getDietListForGraphInternal($userId,$month,$year);
			$monthDietValue  = array_filter($monthDietValue , function($value) { return $value !== null; });
			$recordedValues = count($monthDietValue);
			if(array_sum($monthDietValue) == 0){
				return 0;
			}else{
				return (int)(($goalValue*$recordedValues)/array_sum($monthDietValue)*100);
			}
	}
	private function getDietListForGraphInternal($userId,$month,$year){
		$format = 'Y-m-d';
		$oFirst = DateTime::createFromFormat($format, $year.'-'.($month).'-1');
		$oLast  = DateTime::createFromFormat($format, $year.'-'.$month.'-'.cal_days_in_month(CAL_GREGORIAN, $month, $year));
		$oLast->setTime(23, 59, 59);
		$yearDifference = (int)date("Y") - $year;
		if($yearDifference != 0){
			$oFirst->modify('-'.$yearDifference.' year');
			$oLast->modify('-'.$yearDifference.' year');
		}
		$oFirstTimeStamp = $oFirst->getTimestamp();
		$oLastTimeStamp = $oLast->getTimestamp();
		$query = $this->db->where(array('created_at < '=>$oLastTimeStamp,'created_at > '=>$oFirstTimeStamp,'user_id'=>$userId))->order_by('created_at','ASC')->get('diet_assessment');
		$dietAssesmentList = array();
		$numberOfDaysInMonth = cal_days_in_month(CAL_GREGORIAN, $month, $year);
		$array_index = 0;
		$array_diet_list = array();
		foreach($query->result() as $row)
		{
			array_push($array_diet_list, $row);
		}
		for($i=0; $i<=$numberOfDaysInMonth; $i++)
		{
			$timeStartOfDay = $oFirst->getTimestamp();
			$oFirst->modify('+1 day');
			$timeOfDayEnd = $oFirst->getTimestamp();
			if($array_index < count($array_diet_list)){
				if($array_diet_list[$array_index]->created_at < $timeOfDayEnd && $array_diet_list[$array_index]->created_at > $timeStartOfDay){
					$sumOfCaloriesOfOneDay = 0;
					while( $array_index < count($array_diet_list) && $array_diet_list[$array_index]->created_at < $timeOfDayEnd && $array_diet_list[$array_index]->created_at > $timeStartOfDay){
						$sumOfCaloriesOfOneDay += (int)$array_diet_list[$array_index]->calories;
						$array_index++;
					}
					array_push($dietAssesmentList, $sumOfCaloriesOfOneDay);
				}else{
					array_push($dietAssesmentList, null);
				}
			}else{
				array_push($dietAssesmentList, null);
			}
		}
		return $dietAssesmentList;
	}
	private function getGraphValueForWeigth($userId){
			$todayDate =  new DateTime();
			$month = (int)$todayDate->format("m");
			$year = (int)$todayDate->format("Y");
			$lastWeigth = $this->getLastWeightInternal($userId);
			$firstWeigth = $this->getFirstWeightInternal($userId);
			$goalValue = $this->getGoalByTypeInternal($userId,1);
			
			if($goalValue != 0) {
			    $value = (($firstWeigth-$lastWeigth)/$goalValue)*100;
			}
			else {
			    $value = 0;
			}
			return $value;
			
	}
	private function getLastWeightInternal($userId){
		$query = $this->db->select('entered_at, weight')->select_max('entered_at')->where(array('user_id'=>$userId))->get('weight_assessment');
		if(count($query->result()) > 0){
			return (int)$query->row()->weight;
		}else{
			return 0;
		}
	}
	private function getFirstWeightInternal($userId){
		$query = $this->db->select('entered_at, weight')->select_min('entered_at')->where(array('user_id'=>$userId))->get('weight_assessment');
		if(count($query->result()) > 0){
			return (int)$query->row()->weight;
		}else{
			return 0;
		}
	}
	private function getGoalByTypeInternal($userId,$goalType){
		$query = $this->db->get_where('goal',array('goal_type' => $goalType,'user_id'=>$userId));
		foreach($query->result() as $row)
		{
			return $row->goal_data;
		}
	}
	private function getLastWeightInternalByMonth($userId,$month,$year){
		$format = 'Y-m-d';
		$oFirst = DateTime::createFromFormat($format, $year.'-'.($month).'-1');
		$oLast  = DateTime::createFromFormat($format, $year.'-'.$month.'-'.cal_days_in_month(CAL_GREGORIAN, $month, $year));
		$oLast->setTime(23, 59, 59);
		$yearDifference = (int)date("Y") - $year;
		if($yearDifference != 0){
			$oFirst->modify('-'.$yearDifference.' year');
			$oLast->modify('-'.$yearDifference.' year');
		}
		$oFirstTimeStamp = $oFirst->getTimestamp();
		$oLastTimeStamp = $oLast->getTimestamp();
		$query = $this->db->select('entered_at, weight')->order_by('entered_at','DSC')->where(array('entered_at < '=>$oLastTimeStamp,'entered_at > '=>$oFirstTimeStamp,'user_id'=>$userId))->get('weight_assessment');
		if(count($query->result()) > 0){
			foreach($query->result() as $row)
			{
				return (int)$row()->weight;
			}
		}else{
			return PHP_INT_MIN;
		}
	}
	public function getWeigthListForGraph()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','month','year'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$response['response'] = $this->getWeigthListForGraphInternal($userProperties['userId'],$jsonObject['month'],$jsonObject['year']);
		}
		$this->output->set_output(json_encode($response));
	}
	private function getWeigthListForGraphInternal($userId,$month,$year){
		$format = 'Y-m-d';
		$oFirst = DateTime::createFromFormat($format, $year.'-'.($month).'-1');
		$oLast  = DateTime::createFromFormat($format, $year.'-'.$month.'-'.cal_days_in_month(CAL_GREGORIAN, $month, $year));
		$oLast->setTime(23, 59, 59);
		$yearDifference = (int)date("Y") - $year;
		if($yearDifference != 0){
			$oFirst->modify('-'.$yearDifference.' year');
			$oLast->modify('-'.$yearDifference.' year');
		}
		$oFirstTimeStamp = $oFirst->getTimestamp();
		$oLastTimeStamp = $oLast->getTimestamp();
		$query = $this->db->where(array('entered_at < '=>$oLastTimeStamp,'entered_at > '=>$oFirstTimeStamp,'user_id'=>$userId))->order_by('entered_at','ASC')->get('weight_assessment');
		$weigthAssesmentList = array();
		$numberOfDaysInMonth = cal_days_in_month(CAL_GREGORIAN, $month, $year);
		$array_index = 0;
		$array_weigth_list = array();
		foreach($query->result() as $row)
		{
			array_push($array_weigth_list, $row);
		}
		for($i=0; $i<=$numberOfDaysInMonth; $i++)
		{
			$timeStartOfDay = $oFirst->getTimestamp();
			$oFirst->modify('+1 day');
			$timeOfDayEnd = $oFirst->getTimestamp();
			if($array_index < count($array_weigth_list)){
				if($array_weigth_list[$array_index]->entered_at < $timeOfDayEnd && $array_weigth_list[$array_index]->entered_at > $timeStartOfDay){
					array_push($weigthAssesmentList, (int)$array_weigth_list[$array_index]->weigth);
					$array_index++;
				}else{
					array_push($weigthAssesmentList, null);
				}
			}else{
				array_push($weigthAssesmentList, null);
			}
		}
		return $weigthAssesmentList;
	}
	public function updateOrAddGoal()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','goals'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			if(count($jsonObject['goals']) > 0){
				$goalList = array();
				for($i=0; $i<count($jsonObject['goals']); $i++)
				{
					$goal = $jsonObject['goals'][$i];
					$goal['user_id'] = $userProperties['userId'];
					$this->db->replace('goal', $goal);
					$goal['id'] = $this->db->insert_id();
					array_push($goalList, $goal);
				}
				$response['response'] = $goalList;
			}else{
				$response['response'] = "Goal list empty.";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function updateOrAddExcerciseAssesment()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','excerciseAssesment'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			if(count($jsonObject['excerciseAssesment']) > 0){
				$excerciseAssesmentList = array();
				for($i=0; $i<count($jsonObject['excerciseAssesment']); $i++)
				{
					$excerciseAssesment = $jsonObject['excerciseAssesment'][$i];
					$excerciseAssesment['user_id'] = $userProperties['userId'];
					$this->db->replace('excercise_assessment', $excerciseAssesment);
					$excerciseAssesment['id'] = $this->db->insert_id();
					array_push($excerciseAssesmentList, $excerciseAssesment);
				}
				$response['response'] = $excerciseAssesmentList;
			}else{
				$response['response'] = "Excercise List empty.";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function getExcerciseAssesment()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','startTime','endTime'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$excerciseAssesmentList = array();
			$query = $this->db->get_where('excercise_assessment',array('created_at >= ' => $jsonObject['startTime'],'created_at <= '=>$jsonObject['endTime'],'user_id'=>$userProperties['userId'],'isActive'=>1));
			foreach($query->result() as $row)
			{
				array_push($excerciseAssesmentList, $row);
			}
			$response['response'] = $excerciseAssesmentList;
		}
		$this->output->set_output(json_encode($response));
	}
	public function updateOrAddDietAssesment()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','dietAssesment'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			if(count($jsonObject['dietAssesment']) > 0){
				$dietAssesmentList = array();
				for($i=0; $i<count($jsonObject['dietAssesment']); $i++)
				{
					$dietAssesment = $jsonObject['dietAssesment'][$i];
					$dietAssesment['user_id'] = $userProperties['userId'];
					$this->db->replace('diet_assessment', $dietAssesment);
					$dietAssesment['id'] = $this->db->insert_id();
					array_push($dietAssesmentList, $dietAssesment);
				}
				$response['response'] = $dietAssesmentList;
			}else{
				$response['response'] = "Diet List empty.";
				$response['responseCode'] = 400;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function getDietAssesment()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','startTime','endTime'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$dietAssesmentList = array();
			$query = $this->db->get_where('diet_assessment',array('created_at >= ' => $jsonObject['startTime'],'created_at <= '=>$jsonObject['endTime'],'user_id'=>$userProperties['userId']));
			foreach($query->result() as $row)
			{
				array_push($dietAssesmentList, $row);
			}
			$response['response'] = $dietAssesmentList;
		}
		$this->output->set_output(json_encode($response));
	}
	public function sendMessageByUser()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','subject','messageText'),$jsonObject);
		if($response['responseCode'] == 200){
			try {
					//get user properties by token.
				$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
				$message = array('subject'=>$jsonObject['subject'],'messageText'=>$jsonObject['messageText'],'receiverType'=>1,'read_status'=>0,'created_at'=>$this->getCurrentTime());
				$message['user_id'] = $userProperties['userId'];
				$this->db->replace('message_list', $message);
				$message['id'] = $this->db->insert_id();
				$response['response'] = $message;
			} catch (Exception $e) {
				$response['response'] = "Exception occured at server.";
				$response['responseCode'] = 205;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function setMessageAsRead()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token','messageId'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$appointmentList = array();
			$this->db->set('read_status', 1);
            $this->db->where('id', $jsonObject['messageId']);
            $this->db->update('message_list');
		}
		$this->output->set_output(json_encode($response));
	}
	public function getAppoitmentOfPatient()
	{
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
			$appointmentList = array();
			$query = $this->db->get_where('appointment',array('patient_id'=>$userProperties['userId']));
			foreach($query->result() as $row)
			{
				array_push($appointmentList, $row);
			}
			$response['response'] = $appointmentList;
		}
		$this->output->set_output(json_encode($response));
	}
	private function getMessagesByType($messageType){
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			try {
				$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
				$query = $this->db->where(array('user_ID'=>$userProperties['userId'],'receiverType'=>$messageType))->order_by('created_at')->get('message_list');
				$messageList = array();
				foreach($query->result() as $row)
				{
					array_push($messageList, $row);
				}
				$response['response'] = $messageList;
			} catch (Exception $e) {
				$response['response'] = "Exception occured at server.";
				$response['responseCode'] = 205;
			}
		}
		return $response;
	}
	private function getInboxUnreadCount(){
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token'),$jsonObject);
		if($response['responseCode'] == 200){
			try {
				$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
				return $this->db->where(array('user_ID'=>$userProperties['userId'],'receiverType'=>2,'read_status'=>0))->from('message_list')->count_all_results();
			} catch (Exception $e) {
				return 0;
			}
		}
		return 0;
	}
	public function outBoxMessages()
	{
		$response = $this->getMessagesByType(1);
		$this->output->set_output(json_encode($response));
	}
	public function inBoxMessages()
	{
		$response = $this->getMessagesByType(2);
		$this->output->set_output(json_encode($response));
	}
	private function getLinksByType($linkType){
		$jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			try {
				$query = $this->db->get_where('topicsofinterest',array('link_type'=>$linkType));
				$linkList = array();
				foreach($query->result() as $row)
				{
					array_push($linkList, $row);
				}
				$response['response'] = $linkList;
			} catch (Exception $e) {
				$response['response'] = "Exception occured at server.";
				$response['responseCode'] = 205;
			}
		}
		return $response;
	}
	public function getAllWeights(){
	    $jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			try {
				$userProperties = $this->getUserPropertiesByToken($jsonObject['token']);
				$query = $this->db->select('entered_at, weight')->where(array('user_id'=>$userProperties['userId']))->order_by("entered_at", "DESC")->get('weight_assessment');
		        	$linkList = array();
    				foreach($query->result() as $row)
    				{
    					array_push($linkList, $row);
    				}
    				$response['response'] = $linkList;
			} catch (Exception $e) {
				$response['response'] = "Exception occured at server.";
				$response['responseCode'] = 205;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function getLinks(){
	    $jsonObject =array();
		$response = $this->checkBasicRequirementOfApi('post',array('token'),$jsonObject);
		if($response['responseCode'] == 200){
				//get user properties by token.
			try {
				$query = $this->db->get('topicsofinterest');
				$linkList = array();
				foreach($query->result() as $row)
				{
					array_push($linkList, $row);
				}
				$response['response'] = $linkList;
			} catch (Exception $e) {
				$response['response'] = "Exception occured at server.";
				$response['responseCode'] = 205;
			}
		}
		$this->output->set_output(json_encode($response));
	}
	public function videoLinks()
	{
		$response = $this->getLinksByType(0);
		$this->output->set_output(json_encode($response));
	}
	public function webLinks()
	{
		$response = $this->getLinksByType(1);
		$this->output->set_output(json_encode($response));
	}
}
