<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');



class patient extends CI_Controller {

	public function __construct() {

		parent::__construct();

		$this->load->model('patient_model');

		$this->load->model('topic_model');

	}

	public function index()

	{

		if($this->session->userdata('is_logged_in') !== FALSE){

            $this->session->set_userdata(array('is_sorted_type' => 0));

			$this->showDashboard();

		}

		else{

			$this->load->view('login_form');

		}

	}

	function load(){

		$this->load->library('form_validation');

		$this->form_validation->set_rules('name', 'Name', 'trim|required');

		$this->form_validation->set_rules('password', 'Password', 'trim|required');

		if ($this->form_validation->run() == FALSE){

			$this->load->view('login_form');

		}

		else{					

			$user_name = $this->input->post("name");

			$password = md5($this->input->post("password"));

			if ($this->verifyUser($user_name, $password)){

				$user_detail = $this->getUserDetail($user_name);

				$this->session->set_userdata(array('user_name' => $user_name, 'is_logged_in' => true, 'first_name' => $user_detail['first_name'], 'last_name' => $user_detail['last_name'], 'email' => $user_detail['email']));

				redirect('patient/showDashboard');

			}

			else{				

				$data['message'] = $this->checkRetry($user_name);

				$this->load->view('login_form', $data);		

			}

		}

	}

	function getUserDetail($user_name){

		$this->db->select('*')->from('admin_user')->where('user_name', base64_url_encode($user_name));

		$query = $this->db->get()->result();

		return array('first_name' => base64_url_decode($query[0]->first_name),

				'last_name' => base64_url_decode($query[0]->last_name),			

				'email' => base64_url_decode($query[0]->contact_email));			

	}

	function verifyUser($user_name, $password){

		$this->load->model('user_model');

		if($this->user_model->checkUser($user_name, $password)){

			return true;

		}

		return false;

	}

        function checkRetry($user_name){

		return $this->user_model->checkRetry($user_name);

        }

	function showDashboard(){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$config['base_url'] = site_url('patient/showDashboard');

			$config['total_rows'] = $this->patient_model->getTotalPatientCount();
			
			$config['per_page'] = 10;

			$config['num_links'] = 10;

			$config['uri_segment'] = 3;

			$config['full_tag_open'] = '<div id="content" style="text-align:center;"><ul class="pager">';

			$config['full_tag_close'] = '</ul></div>';		

			$config['num_tag_open'] = '<li>';

			$config['num_tag_close'] = '</li>';				

			$config['cur_tag_open'] = '<li class="active1"><a href="#">';

			$config['cur_tag_close'] = '</a></li>';

			$config['prev_tag_open'] = '<li class="first-page">';

			$config['prev_tag_close'] = '</li>';				

			$config['next_tag_open'] = '<li class="last-page">';

			$config['next_tag_close'] = '</li>';
			
			$searchFrom = $this->uri->segment(3);
			$searchOnData = $this->uri->segment(4);
			
			$data['staring_point'] = (!empty($this->uri->segment(3)))?$this->uri->segment(3):0;
            $data['all_patient_rows'] = $this->patient_model->getAllPatientData($config['per_page'], $this->uri->segment(3) , 0 , $searchOnData );

           // print_r($data['all_patient_rows']); die();
            $selected_patient_id = $this->input->post('patient_id');

			if (($selected_patient_id == NULL) && (isset($data['all_patient_rows'][0]))){

                            $selected_patient_id = $data['all_patient_rows'][0]->id;

                        }

			$data['selected_patient_data'] = $this->getPatientDataById($selected_patient_id);

			$data['selected_patient_id'] = $selected_patient_id;

            $data['selected_patient_message'] = $this->getPatientMessageCount($selected_patient_id);

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();
			
			$data['is_tab1'] = true;

			//$this->load->vars($data);

			$this->pagination->initialize($config);
			$this->load->view('patient', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}
	
	function non_registered(){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$config['base_url'] = site_url('patient/non_registered');

			$config['total_rows'] = $this->patient_model->getTotalNonRegisteredPatientCount();
			$config['per_page'] = 10;

			$config['num_links'] = 10;

			$config['uri_segment'] = 3;

			$config['full_tag_open'] = '<div id="content" style="text-align:center;"><ul class="pager">';

			$config['full_tag_close'] = '</ul></div>';		

			$config['num_tag_open'] = '<li>';

			$config['num_tag_close'] = '</li>';				

			$config['cur_tag_open'] = '<li class="active1"><a href="#">';

			$config['cur_tag_close'] = '</a></li>';

			$config['prev_tag_open'] = '<li class="first-page">';

			$config['prev_tag_close'] = '</li>';				

			$config['next_tag_open'] = '<li class="last-page">';

			$config['next_tag_close'] = '</li>';
			
			$searchFrom = $this->uri->segment(3);
			$searchOnData = $this->uri->segment(4);
			
			$data['staring_point'] = (!empty($this->uri->segment(3)))?$this->uri->segment(3):0;
            $data['all_patient_rows'] = $this->patient_model->getAllNewPatientData($config['per_page'], $this->uri->segment(3), 0 , $searchOnData );

           // print_r($data['all_patient_rows']); die();
            $selected_patient_id = $this->input->post('patient_id');

			if (($selected_patient_id == NULL) && (isset($data['all_patient_rows'][0]))){

                            $selected_patient_id = $data['all_patient_rows'][0]->id;

                        }

			$data['selected_patient_data'] = $this->getPatientDataById($selected_patient_id);

			$data['selected_patient_id'] = $selected_patient_id;

            $data['selected_patient_message'] = $this->getPatientMessageCount($selected_patient_id);

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();
			
			$data['is_tab2'] = true;

			//$this->load->vars($data);

			$this->pagination->initialize($config);
			//print_r($data); die();
			$this->load->view('new_patients', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

    function importUsersAjax(){

		$file_element_name = 'file_import';  

		$config['upload_path'] = ASSET_FRONTEND_UPLOADS_PATH;

		$config['allowed_types'] = '*';

		$this->load->library('upload', $config);

		if(!$this->upload->do_upload($file_element_name)) {

			$status = 'error';

				$msg = $this->upload->display_errors('', '');

				$response['msg'] = $msg;

				$response['url'] = ASSET_FRONTEND_UPLOADS_PATH;

				echo json_encode($response);

				die();

		}else {

			$data = array('upload_data' => $this->upload->data());

			$file_name = $data['upload_data']['file_name'];

		}

    	$client_data = import_excel($data['upload_data']['full_path']);

    	$total_entries = count($client_data);

		$i = 0;

    	$total_errors = 0;

    	foreach($client_data as $data) {

			$pieces = explode(' ',$data[1]);

			$first_name = base64_url_encode($pieces[0]);

			$last_name = base64_url_encode($pieces[1]);

			$phone = base64_url_encode($data[2]);

			$email = base64_url_encode($data[3]);

			$gender = $data[4];

			$weight = $data[5];

			$height = $data[6];

			$dob = base64_url_encode($data[7]);

    		$response = $this->patient_model->import($first_name,$last_name,$phone,$email,$gender,$weight,$height,$dob);

    		if($response==false){

				$total_errors++;

			}

    		$i++;

    		

    	}

    	$total = $total_entries - $total_errors;

    	$msg = $total.' new records have been added.';

    	if($total_errors!=0){

			$msg = $total.' out of '.$total_entries.' new records have been added.';

			$msg .= ' Please check phone and emails to avoid users duplication.';

		}

		$url = '';

		$fResponse['msg'] = $msg;

		$fResponse['url'] = $url;

		echo json_encode($fResponse);

		die();

	}

    function showSortedDashboard($type = 0){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$config['base_url'] = site_url('patient/showDashboard');

			$config['total_rows'] = $this->patient_model->getTotalPatientCount();

			$config['per_page'] = 10;

			$config['num_links'] = 10;

			$config['uri_segment'] = 3;

			$config['full_tag_open'] = '<div id="content" style="text-align:center;"><ul class="pager">';

			$config['full_tag_close'] = '</ul></div>';		

			$config['num_tag_open'] = '<li>'; 

			$config['num_tag_close'] = '</li>';				

			$config['cur_tag_open'] = '<li class="active1"><a href="#">';

			$config['cur_tag_close'] = '</a></li>';

			$config['prev_tag_open'] = '<li class="first-page">';

			$config['prev_tag_close'] = '</li>';				

			$config['next_tag_open'] = '<li class="last-page">';

			$config['next_tag_close'] = '</li>';

            

            if ($type == 2) {

                $_text = $_GET['data'];

                $config['total_rows'] = $this->patient_model->getSearchTotalPatientCount($_text);

                $data['all_patient_rows'] = $this->patient_model->searchPatientData($config['per_page'], $this->uri->segment(4), $_text);
	
            }

            else {

                if ($type == 0) {

                    $this->session->set_userdata(array('is_sorted_type' => 0));

                }

                else {

                    $this->session->set_userdata(array('is_sorted_type' => 1));

                }

                $data['all_patient_rows'] = $this->patient_model->getAllPatientData($config['per_page'], $this->uri->segment(4), $type);

            }

            

            $selected_patient_id = $this->input->post('patient_id');

			if (($selected_patient_id == NULL) && (isset($data['all_patient_rows'][0])))

				$selected_patient_id = $data['all_patient_rows'][0]->id;

			$data['selected_patient_data'] = $this->getPatientDataById($selected_patient_id);

			$data['selected_patient_id'] = $selected_patient_id;

            $data['selected_patient_message'] = $this->getPatientMessageCount($selected_patient_id);

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			//$this->load->vars($data);

			$this->pagination->initialize($config);
			$this->load->view('patient', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

    

	function getPatientDataById($patient_id){

		return $this->patient_model->getPatientDataById($patient_id);

	}

        function getAllUnreadMesages(){

            $list = $this->patient_model->getAllUnreadMesages();

            foreach ($list as $value) {

                $patient =$this->getPatientDataById($value->user_ID);

                $value->name = $patient[0]->user_last_name;

            }

            echo json_encode($list);

	}

    function getPatientMessageCount($patient_id){

		return $this->patient_model->getPatientMessageCount($patient_id);

	}

	function getPatientRighViewById(){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$patient_id = $this->input->post('patient_id');

			$data['selected_patient_id'] = $patient_id;

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$this->load->view('components/right2', $data);

		}

		else{

			echo "LOGGEDOUT";

		}	

	}

	function logout(){

		$this->session->unset_userdata('is_logged_in');

		$this->load->view('login_form');

	}

	function self_assessment($patient_id){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);
			
			$data['selected_patient_goal_data'] = $this->patient_model->getAllGoal($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_habits_data'] = $this->patient_model->getPatientHabitsById($patient_id);
			
			$habitsQuestions = array();
			
			$habitsQuestions[1] = "What time do you usually wake up ?";
			$habitsQuestions[2] = "What time do you usually sleep?";
			$habitsQuestions[3] = "Do you take a nap?";
			$habitsQuestions[4] = "What time do you usually take a nap?";
			$habitsQuestions[5] = "How many times a week do you usually exercise?";
			$habitsQuestions[6] = "How many times a week do you usually eat from a restaurant?";
			$habitsQuestions[7] = "Do you smoke?";
			
			$data['userID'] = $patient_id;
			
			$data['habits_questions'] = $habitsQuestions;
			$data['habits_data'] = $this->patient_model->getHabitsData( " user_id = $patient_id ");

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			$data['is_tab1'] = true;
			
			$this->load->view('self_assessment', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function exercise_assessment($patient_id){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_userevaluation_data'] = $this->patient_model->getPatientExerciseAssessmentById($patient_id);

			$data['is_tab2'] = true;

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			$this->load->view('exercise_assessment', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function goal_assessment($patient_id){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_goal_data'] = $this->patient_model->getAllGoal($patient_id);

			$data['is_tab3'] = true;

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			$this->load->view('goal_assessment', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function weight_assessment($patient_id){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_weight_data'] = $this->patient_model->getPatientWeight($patient_id);

			$data['is_tab4'] = true;

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			$this->load->view('weight_assessment', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function diet_assessment($patient_id){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_diet_data'] = $this->patient_model->getPatientDietAssessment($patient_id);

			$data['is_tab5'] = true;

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			$this->load->view('diet_assessment', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

/*	function pain_assessment($patient_id){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_userevaluation_data'] = $this->patient_model->getPatientUserEvaluationDataById($patient_id);

			$data['pain_position_data'] = $this->patient_model->getPatientPainPositionData($patient_id);

			$data['is_tab2'] = true;

			$this->load->view('pain_assessment', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}*/

	function activity_function($patient_id){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_userevaluation_data'] = $this->patient_model->getPatientUserEvaluationDataById($patient_id);

			$data['is_tab3'] = true;

			$this->load->view('activity_function', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function mood_emotional_distress($patient_id){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_userevaluation_data'] = $this->patient_model->getPatientUserEvaluationDataById($patient_id);

			$data['is_tab4'] = true;

			$this->load->view('mood_emotional_distress', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function medication_use($patient_id){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$data['selected_patient_id'] = $patient_id;

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            		$data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_userevaluation_data'] = $this->patient_model->getPatientUserEvaluationDataById($patient_id);

			$data['is_tab5'] = true;

			$this->load->view('medication_use', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function daily_assessment($patient_id){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['daily_review_cycle'] = "Week";

			$data['selected_patient_dailyreviews_dates'] = $this->patient_model->getPatientDailyReviewDataById($patient_id, "Week");

			if(!isset($data['selected_patient_dailyreviews_dates'][0])){

				$data['daily_review_cycle'] = "Month";

				$data['selected_patient_dailyreviews_dates'] = $this->patient_model->getPatientDailyReviewDataById($patient_id, "Month");

				if(!isset($data['selected_patient_dailyreviews_dates'][0])){

					$data['daily_review_cycle'] = "Year";

					$data['selected_patient_dailyreviews_dates'] = $this->patient_model->getPatientDailyReviewDataById($patient_id, "Year");

					if(!isset($data['selected_patient_dailyreviews_dates'][0])){

						$data['daily_review_cycle'] = "All";

						$data['selected_patient_dailyreviews_dates'] = $this->patient_model->getPatientDailyReviewDataById($patient_id, "All");

					}

				}

			}

			$data['selected_date'] = $this->patient_model->getPatientDailyReviewLastDateById($patient_id);

			if(!isset($data['selected_date'][0]))

				$data['selected_date'] = "";

			else

				$data['selected_date'] = $data['selected_date'][0]->updatedAt;

			//die($data['selected_date']);

			//$data['selected_date'] = "2013-10-14 00:00:00";

			$data['selected_date_data'] = $this->patient_model->getPatientDailyReviewDataByDate($patient_id, $data['selected_date']);

			

			$data['selected_date_data_reviewtasks'] = array();

			foreach($data['selected_date_data'] as $date_data){

				$data['selected_date_data_reviewtasks'][$date_data->reviewID] = $this->patient_model->getPatientTaskReviewByReviewId($patient_id, $date_data->reviewID);

			}

			$this->load->view('daily_assessment', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function daily_assessment_by_period(){

		if($this->session->userdata('is_logged_in') !== FALSE){	

			$daily_review_cycle = $this->input->post('review_cycle');

			$patient_id = $this->input->post('patient_id');

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$daily_review_cycle = ucwords(substr($daily_review_cycle, 0, strlen($daily_review_cycle) - 1));

			$data['daily_review_cycle'] = $daily_review_cycle;

			$data['selected_patient_dailyreviews_dates'] = $this->patient_model->getPatientDailyReviewDataById($patient_id,  $daily_review_cycle);

			//die($this->db->last_query());

			$data['selected_date'] = $this->patient_model->getPatientDailyReviewLastDateById($patient_id);

			if(!isset($data['selected_date'][0]))

				$data['selected_date'] = "";

			else

				$data['selected_date'] = $data['selected_date'][0]->updatedAt;

			//die($data['selected_date']);

			//$data['selected_date'] = "2013-10-14 00:00:00";

			$data['selected_date_data'] = $this->patient_model->getPatientDailyReviewDataByDate($patient_id, $data['selected_date']);

			

			$data['selected_date_data_reviewtasks'] = array();

			foreach($data['selected_date_data'] as $date_data){

				$data['selected_date_data_reviewtasks'][$date_data->reviewID] = $this->patient_model->getPatientTaskReviewByReviewId($patient_id, $date_data->reviewID);

			}

			

			$this->load->view('daily_assessment_components/daily_assessment_content', $data);

		}

		else{

			echo "LOGGEDOUT";

		}

	}

	function daily_assessment_by_date(){

		if($this->session->userdata('is_logged_in') !== FALSE){	

			$daily_review_cycle = $this->input->post('review_cycle');

			$patient_id = $this->input->post('patient_id');

			$selected_date = $this->input->post('select_date');

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$daily_review_cycle = ucwords(substr($daily_review_cycle, 0, strlen($daily_review_cycle) - 1));

			$data['daily_review_cycle'] = $daily_review_cycle;

			$data['selected_patient_dailyreviews_dates'] = $this->patient_model->getPatientDailyReviewDataById($patient_id,  $daily_review_cycle);

			//die($this->db->last_query());

			$data['selected_date'] = $selected_date;

			//die($data['selected_date']);

			//$data['selected_date'] = "2013-10-14 00:00:00";

			$data['selected_date_data'] = $this->patient_model->getPatientDailyReviewDataByDate($patient_id, $data['selected_date']);

			

			$data['selected_date_data_reviewtasks'] = array();

			foreach($data['selected_date_data'] as $date_data){

				$data['selected_date_data_reviewtasks'][$date_data->reviewID] = $this->patient_model->getPatientTaskReviewByReviewId($patient_id, $date_data->reviewID);

			}

			

			$this->load->view('daily_assessment_components/daily_assessment_content', $data);

		}

		else{

			echo "LOGGEDOUT";

		}

	}	

	function sendMessage(){
		if($this->session->userdata('is_logged_in') !== FALSE){	

			$message = $this->input->post('message');

			$subject = $this->input->post('subject');

			$patient_id = $this->input->post('patient_id');
			
			if($patient_id == 'all-users')
			{
				$all_patient_data =  $this->patient_model->getPatientDataAll();
				if(!empty($all_patient_data)){
					$all_patient_data = json_decode(json_encode($all_patient_data), True);
					//print_r($data['all_patient_data']); die();
					$list = $all_patient_data;
					if(!empty($list)){
						foreach($list as $key=>$info){
							if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
								unset($list[$key]);
							}else {
								
								$this->patient_model->saveMessage($info['id'], $message, $subject);
			
                        		callSendMessageAPI($info['id'], "New Message Received","message");
							}
						}
						
					}
					
				}
			}else
			{
			
					$this->patient_model->saveMessage($patient_id, $message, $subject);
			
                    callSendMessageAPI($patient_id, "New Message Received","message");
			}
		}

		else{

			echo "LOGGEDOUT";

		}

	}

        function CombinedInbox($patient_id = NULL){

            

		if($this->session->userdata('is_logged_in') !== FALSE){	

			$config['base_url'] = site_url('patient/inbox'). '/' . $patient_id;

			$config['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			$data['total_rows'] = $config['total_rows'];

			$config['per_page'] = 10;

			$config['num_links'] = 10;

			$config['uri_segment'] = 4;

			$config['full_tag_open'] = '<div id="content" style="text-align:center;"><ul class="pager">';

			$config['full_tag_close'] = '</ul></div>';		

			$config['num_tag_open'] = '<li>';

			$config['num_tag_close'] = '</li>';				

			$config['cur_tag_open'] = '<li class="active1"><a href="#">';

			$config['cur_tag_close'] = '</a></li>';

			$config['prev_tag_open'] = '<li class="first-page">';

			$config['prev_tag_close'] = '</li>';				

			$config['next_tag_open'] = '<li class="last-page">';

			$config['next_tag_close'] = '</li>';
			
			$searchableData = $this->uri->segment(3);
			
			
			$data['all_patient_rows'] = $this->patient_model->getPatientReceivedMessageCombinedInbox( $searchableData );

			//die($this->db->last_query());

			$selected_patient_id = $patient_id;

			$data['selected_patient_data'] = $this->getPatientDataById($selected_patient_id);

			$data['selected_patient_id'] = $selected_patient_id;

			$data['selected_patient_message'] = $this->getPatientMessageCount($selected_patient_id);
			
			$data['inbox_count'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			//$this->load->vars($data);
			$data['all_patient_data'] =  $this->patient_model->getPatientDataAll();
			if(!empty($data['all_patient_data'])){
				$data['all_patient_data'] = json_decode(json_encode($data['all_patient_data']), True);
				//print_r($data['all_patient_data']); die();
				$list = $data['all_patient_data'];
				if(!empty($list)){
					foreach($list as $key=>$info){
						if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
							unset($list[$key]);
						}else {
							$list[$key] = (object)$info;
						}
					}
					$list = array_values($list);
				}
				unset($data['all_patient_data']); // $foo is gone
				$data['all_patient_data'] = array(); // $foo is here again
				$data['all_patient_data'] = $list;
			}
			$this->pagination->initialize($config);

			$this->load->view('combinedInbox', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}
	
	function CombinedOutbox($patient_id = NULL){

            

		if($this->session->userdata('is_logged_in') !== FALSE){	

			$config['base_url'] = site_url('patient/CombinedOutbox'). '/' . $patient_id;

			$config['total_rows'] = $this->patient_model->getPatientCombinedOutboxMessageCount();
			//print_r($config['total_rows']); die();
			//$config['total_rows'] = 10;
			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			$config['per_page'] = 10;

			$config['num_links'] = 10;

			$config['uri_segment'] = 4;

			$config['full_tag_open'] = '<div id="content" style="text-align:center;"><ul class="pager">';

			$config['full_tag_close'] = '</ul></div>';		

			$config['num_tag_open'] = '<li>';

			$config['num_tag_close'] = '</li>';				

			$config['cur_tag_open'] = '<li class="active1"><a href="#">';

			$config['cur_tag_close'] = '</a></li>';

			$config['prev_tag_open'] = '<li class="first-page">';

			$config['prev_tag_close'] = '</li>';				

			$config['next_tag_open'] = '<li class="last-page">';

			$config['next_tag_close'] = '</li>';

			$searchableData = $this->uri->segment(3);

			$data['all_patient_rows'] = $this->patient_model->getPatientReceivedMessageCombinedOutbox($searchableData);
			//print_r($data['all_patient_rows']); die();
			//die($this->db->last_query());

			$selected_patient_id = $patient_id;

			$data['selected_patient_data'] = $this->getPatientDataById($selected_patient_id);

			$data['selected_patient_id'] = $selected_patient_id;

			$data['selected_patient_message'] = $this->getPatientMessageCount($selected_patient_id);
			
			$data['inbox_count'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			//$this->load->vars($data);
			$data['all_patient_data'] =  $this->patient_model->getPatientDataAll();
			if(!empty($data['all_patient_data'])){
				$data['all_patient_data'] = json_decode(json_encode($data['all_patient_data']), True);
				//print_r($data['all_patient_data']); die();
				$list = $data['all_patient_data'];
				if(!empty($list)){
					foreach($list as $key=>$info){
						if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
							unset($list[$key]);
						}else {
							$list[$key] = (object)$info;
						}
					}
					$list = array_values($list);
				}
				unset($data['all_patient_data']); // $foo is gone
				$data['all_patient_data'] = array(); // $foo is here again
				$data['all_patient_data'] = $list;
			}
			$this->pagination->initialize($config);

			$this->load->view('combinedOutbox', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function inbox($patient_id = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){	

			$config['base_url'] = site_url('patient/inbox'). '/' . $patient_id;

			$config['total_rows'] = $this->patient_model->getPatientInboxMessageCount($patient_id);

			$config['per_page'] = 10;

			$config['num_links'] = 10;

			$config['uri_segment'] = 4;

			$config['full_tag_open'] = '<div id="content" style="text-align:center;"><ul class="pager">';

			$config['full_tag_close'] = '</ul></div>';		

			$config['num_tag_open'] = '<li>';

			$config['num_tag_close'] = '</li>';				

			$config['cur_tag_open'] = '<li class="active1"><a href="#">';

			$config['cur_tag_close'] = '</a></li>';

			$config['prev_tag_open'] = '<li class="first-page">';

			$config['prev_tag_close'] = '</li>';				

			$config['next_tag_open'] = '<li class="last-page">';

			$config['next_tag_close'] = '</li>';

			$data['all_patient_rows'] = $this->patient_model->getPatientReceivedMessage($config['per_page'], $this->uri->segment(4), $patient_id);

			//die($this->db->last_query());

			$selected_patient_id = $patient_id;

			$data['selected_patient_data'] = $this->getPatientDataById($selected_patient_id);

			$data['selected_patient_id'] = $selected_patient_id;

            $data['selected_patient_message'] = $this->getPatientMessageCount($selected_patient_id);

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			//$this->load->vars($data);

			$this->pagination->initialize($config);

			$this->load->view('inbox', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function outbox($patient_id = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){	

			$config['base_url'] = site_url('patient/outbox'). '/' . $patient_id;

			$config['total_rows'] = $this->patient_model->getPatientOutboxMessageCount($patient_id);

			$config['per_page'] = 10;

			$config['num_links'] = 10;

			$config['uri_segment'] = 4;

			$config['full_tag_open'] = '<div id="content" style="text-align:center;"><ul class="pager">';

			$config['full_tag_close'] = '</ul></div>';		

			$config['num_tag_open'] = '<li>';

			$config['num_tag_close'] = '</li>';				

			$config['cur_tag_open'] = '<li class="active1"><a href="#">';

			$config['cur_tag_close'] = '</a></li>';

			$config['prev_tag_open'] = '<li class="first-page">';

			$config['prev_tag_close'] = '</li>';				

			$config['next_tag_open'] = '<li class="last-page">';

			$config['next_tag_close'] = '</li>';

			$data['all_patient_rows'] = $this->patient_model->getPatientSentMessage($config['per_page'], $this->uri->segment(4), $patient_id);

			//die($this->db->last_query());

			$selected_patient_id = $patient_id;

			$data['selected_patient_data'] = $this->getPatientDataById($selected_patient_id);

			$data['selected_patient_id'] = $selected_patient_id;

            $data['selected_patient_message'] = $this->getPatientMessageCount($selected_patient_id);

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			//$this->load->vars($data);

			$this->pagination->initialize($config);

			$this->load->view('outbox', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function showMessageById($message_id = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$message_id = $this->input->post('message_id');
			
			$message_mode = "";
			
			if( !empty($this->input->post('message_mode')))
			{
				$message_mode = $this->input->post('message_mode');
			}
			
			$data['message_mode'] = $message_mode;
			$this->patient_model->readMessageById($message_id);

			$data['message_content'] = $this->patient_model->getMessageById($message_id);
			
			//$test = $this->db->select('id,user_first_name,user_last_name,patient_ref_no,date_of_birth,phone_number,email,password,isHashed');
			$patient_id =  $data['message_content'][0]->user_ID;
			//$data['message_user'] = $this->db->select('*')->from('user_info')->where('id', $patient_id)->get()->result();
			$data['message_user'] = $this->getPatientDataById($patient_id);
            //print_r($test); die();
			
			
			
			$this->load->view('components/showMessageView', $data);	

		}

		else{

			echo "LOGGEDOUT";

		}

	}

        function showMessageByIdWithReply($message_id = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$message_id = $this->input->post('message_id');

			$this->patient_model->readMessageById($message_id);

			$data['message_content'] = $this->patient_model->getMessageById($message_id);

			$this->load->view('components/showMessageViewWithReply', $data);	

		}

		else{

			echo "LOGGEDOUT";

		}

	}

	function showDiagnosis($patient_id = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){

			echo "<h3 style='color:red'>ATTENTION: DON'T KNOW WHICH COLUMN DATA TO USE FOR THIS</h3>";

		}

		else{

			echo "LOGGEDOUT";

		}

	}

	function showCurrentDisease($patient_id = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){

			if($patient_id == NULL)

				$patient_id = $this->input->post('patient_id');

			$data['current_disease'] = $this->patient_model->getCurrentDisease($patient_id);

			$this->load->view('components/current_disease', $data);

		}

		else{

			echo "LOGGEDOUT";

		}

	}

	function medication_list($patient_id = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){	

			$data['selected_patient_id'] = $patient_id;		

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['medication_list'] = $this->patient_model->getMedicationListByPatientId("pain");

			$data['other_medication_list'] = $this->patient_model->getMedicationListByPatientId("other");

			$this->load->view('medication_list', $data);

		}

		else{

			echo "LOGGEDOUT";

		}

	}

	function deleteMedicineById($patient_id = NULL, $medicine_id = NULL, $medicine_type = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){

			if($medicine_id == NULL)

				$medicine_id = $this->input->post('medicine_id');

			if($patient_id == NULL)

				$patient_id = $this->input->post('patient_id');

			if($medicine_type == NULL)

				$medicine_type = $this->input->post('medicine_type');	

			$this->patient_model->deleteMedicineById($medicine_id);

			if($medicine_type == "pain"){

				$data['medication_list'] = $this->patient_model->getMedicationListByPatientId("pain");

				$this->load->view('components/current_medication', $data);

			}

			else if ($medicine_type == "other"){

				$data['other_medication_list'] = $this->patient_model->getMedicationListByPatientId("other");

				$this->load->view('components/other_medication', $data);

			}

		}

		else{

			echo "LOGGEDOUT";

		}

	}

	function addMedicine($patient_id = NULL, $medicine_name = NULL, $medicine_type = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){

			if($medicine_name == NULL)

				$medicine_name = $this->input->post('medicine_name');

			if($patient_id == NULL)

				$patient_id = $this->input->post('patient_id');	

			if($medicine_type == NULL)

				$medicine_type = $this->input->post('medicine_type');	

			$this->patient_model->addMedicine($patient_id, $medicine_name, $medicine_type);

			if($medicine_type == "pain"){

				$data['medication_list'] = $this->patient_model->getMedicationListByPatientId("pain");

				$this->load->view('components/current_medication', $data);

			}

			else if ($medicine_type == "other"){

				$data['other_medication_list'] = $this->patient_model->getMedicationListByPatientId("other");

				$this->load->view('components/other_medication', $data);

			}

		}

		else{

			echo "LOGGEDOUT";

		}

	}

	function topic_of_interest($patient_id = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$config['base_url'] = site_url('patient/topic_of_interest')."/".$patient_id;

			$config['total_rows'] = $this->topic_model->getTotalTopicCount();

			$config['per_page'] = 10;

			$config['num_links'] = 10;

			$config['uri_segment'] = 4;

			$config['full_tag_open'] = '<div id="content" style="text-align:center;"><ul class="pager">';

			$config['full_tag_close'] = '</ul></div>';		

			$config['num_tag_open'] = '<li>';

			$config['num_tag_close'] = '</li>';				

			$config['cur_tag_open'] = '<li class="active1"><a href="#">';

			$config['cur_tag_close'] = '</a></li>';

			$config['prev_tag_open'] = '<li class="first-page">';

			$config['prev_tag_close'] = '</li>';				

			$config['next_tag_open'] = '<li class="last-page">';

			$config['next_tag_close'] = '</li>';

			$data['all_topic_rows'] = $this->topic_model->getAllTopicData($config['per_page'], $this->uri->segment(4));

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_id'] = $patient_id;

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			//$this->load->vars($data);

			$this->pagination->initialize($config);

			$this->load->view('topic_of_interest', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

	function addNewTopic($topic_name,$topic_url,$file_name){

		if($this->session->userdata('is_logged_in') !== FALSE){

			return $this->topic_model->addNewTopic($topic_name,$topic_url,$file_name);

		}

		else{

			echo "LOGGEDOUT";

		}

	}
	
	function deleteTopic(){

		if($this->session->userdata('is_logged_in') !== FALSE){
			$topic_id = $this->input->post('topic_id');
			return $this->topic_model->deleteTopic($topic_id);

		}

		else{

			echo "LOGGEDOUT";

		}

	}
	
	function deleteUser(){

		if($this->session->userdata('is_logged_in') !== FALSE){
			$user_id = $this->input->post('user_id');
			return $this->patient_model->deleteUser($user_id);

		}

		else{

			echo "LOGGEDOUT";

		}

	}
	
	function addUser(){

		if($this->session->userdata('is_logged_in') !== FALSE){
			$email = $this->input->post('email');
			$phone_number = $this->input->post('phone_number');
			//$email = base64_url_encode($email);
			//$userExist = $this->patient_model->checkUserExist($email);

			if( trim($email) != "" )
			{
				$checkUserExistVals = $this->patient_model->checkDupplicateUser($email , "Email");
			}

			if( trim($phone_number) != "" )
			{
				$checkUserExistVals = $this->patient_model->checkDupplicateUser($phone_number , "Cellno");
			}
			
			$totalCount  = $checkUserExistVals[0]["totalCount"];
			
			$userExist = $totalCount;
			
			//echo ($phone_number); die();
			if(empty($userExist)){
				$data = array(
				'email' => $email,
				'phone_number' => $phone_number,
				); 
				//echo print_r($data); die();
				return $this->patient_model->addUser($data);
			}else{
				echo "1";
			}

		}else{
			echo "LOGGED OUT";
		}

	}

	function editTopic(){

		if($this->session->userdata('is_logged_in') !== FALSE){
			$edit_topic_id = $_POST['edit_topic_id'];

			$edit_topic_name = $_POST['edit_topic_name'];
			
			$edit_topic_url = $_POST['edit_topic_url'];
			
			$edit_topic_file_url = $_POST['edit_topic_file'];
			
			//echo $edit_topic_file_url; die();
			if(empty($edit_topic_file_url)){
				$final_name = $this->topic_model->getTopicCurrentFileById($edit_topic_id);
				$this->topic_model->editTopic($edit_topic_id, $edit_topic_name, $edit_topic_url, $final_name);
				//echo "Uploaded";
			}else{
				$temp_array = explode("\\", $edit_topic_file_url);
				$file_name = end($temp_array);
				
				$allowedExts = array("jpg", "png", "jpeg", "gif");

				$temp = explode(".", $file_name);
				
				$only_name = $temp[0];
				$extension = end($temp); 
				
				if(in_array($extension, $allowedExts)){
					$final_name = $only_name.uniqid().".".$extension; 
					$location = ASSET_FRONTEND_UPLOADS_PATH.'interest/';

					if (file_exists($location . $final_name))

					{

						echo  $final_name . " already exists. ";

					}

					else

					{

						move_uploaded_file($_FILES["file"]["tmp_name"],

						$location . $final_name);
						
						$this->topic_model->editTopic($edit_topic_id, $edit_topic_name, $edit_topic_url, $final_name);
						//echo "Uploaded";

					}
					
				}else{
					
					echo "Invalid file";
				}
			}
		}

		else{

			echo "LOGGEDOUT";

		}

	}

    

	function upload_content_file(){

		if($this->session->userdata('is_logged_in') !== FALSE){
			$allowedExts = array("jpg", "png", "jpeg", "gif");

			$temp = explode(".", $_FILES["content_file"]["name"]);

			$extension = end($temp);

			if ((($_FILES["content_file"]["type"] == "image/jpg" || "image/png" || "image/jpeg" || "image/gif"))

			&& in_array($extension, $allowedExts))

            {

                if ($_FILES["content_file"]["error"] > 0)

                {

                    echo "Return Code: " . $_FILES["content_file"]["error"] . "<br>";

				}

                else

				{

				    $location = ASSET_FRONTEND_UPLOADS_PATH.'interest/';

                    if (file_exists($location . $_FILES["content_file"]["name"]))

                    {

                        echo $_FILES["content_file"]["name"] . " already exists. ";

                    }

                    else

                    {

                        move_uploaded_file($_FILES["content_file"]["tmp_name"],

                        $location . $_FILES["content_file"]["name"]);

                        echo "Uploaded";

                    }

                }

            }

            else {

                echo "Invalid file";

            }

		}

		else{

			echo "LOGGEDOUT";

		}

	}

    

    function upload_file_document()

    {

        if($this->session->userdata('is_logged_in') !== FALSE)

        {

            $allowedExts = array("gif", "jpeg", "JPG", "jpg", "png", "pdf","html", "htm");

			$temp = explode(".", $_FILES["document_file"]["name"]);

			$extension = end($temp);

			die($_FILES["document_file"]["type"]);

            

			if ((($_FILES["document_file"]["type"] == "image/gif")

			|| ($_FILES["document_file"]["type"] == "image/jpeg")

			|| ($_FILES["document_file"]["type"] == "image/jpg")

			|| ($_FILES["document_file"]["type"] == "image/pjpeg")

			|| ($_FILES["document_file"]["type"] == "application/pdf")

			|| ($_FILES["document_file"]["type"] == "image/x-png")

            || ($_FILES["document_file"]["type"] == "text/html"))

			&& in_array($extension, $allowedExts))

            {

                if ($_FILES["document_file"]["error"] > 0)

				{

				    echo "Return Code: " . $_FILES["document_file"]["error"] . "<br>";

				}

                else

				{

				    $location = "'../../../uploads/";

                    if (file_exists($location . $_FILES["document_file"]["name"]))

                    {

                        echo $_FILES["document_file"]["name"] . " already exists. ";

                    }

                    else

                    {

                        move_uploaded_file($_FILES["document_file"]["tmp_name"],

                        $location . $_FILES["document_file"]["name"]);

                        echo "Uploaded";

                    }

                }

            }

			else

            {

                echo "Invalid file";

            }

		}

		else{

			echo "LOGGEDOUT";

		}

	}

    

	function upload_file_audio()

    {

        if($this->session->userdata('is_logged_in') !== FALSE)

        {

            $allowedExts = array("mp3", "wav", "mpeg", "mpeg", "x-mpeg", "x-mp3", "mpeg3", "x-mpeg3", "mpg", "x-mpg", "x-mpegaudio");

            

            $temp = explode(".", $_FILES["audio_file"]["name"]);

			$extension = end($temp);

			if ((($_FILES["audio_file"]["type"] == "audio/mpeg")

			|| ($_FILES["audio_file"]["type"] == "audio/x-mpeg")

			|| ($_FILES["audio_file"]["type"] == "audio/x-mp3")

			|| ($_FILES["audio_file"]["type"] == "audio/mpeg3")

			|| ($_FILES["audio_file"]["type"] == "audio/x-mpeg3")

			|| ($_FILES["audio_file"]["type"] == "audio/mpg")

			|| ($_FILES["audio_file"]["type"] == "audio/x-mpg")

			|| ($_FILES["audio_file"]["type"] == "audio/x-mpegaudio")		

			|| ($_FILES["audio_file"]["type"] == "image/png")

			|| ($_FILES["audio_file"]["type"] == "audio/mp3") 

			|| ($_FILES["audio_file"]["type"] == "audio/wav"))

			&& in_array($extension, $allowedExts))

            {

                if ($_FILES["audio_file"]["error"] > 0)

                {

                    echo "Return Code: " . $_FILES["audio_file"]["error"] . "<br>";

                }

                else

                {

                    $location = "'../../../uploads/";

                    if (file_exists($location . $_FILES["audio_file"]["name"]))

                    {

                        echo $_FILES["audio_file"]["name"] . " already exists.";

                    }

                    else

                    {

                        move_uploaded_file($_FILES["audio_file"]["tmp_name"],

                        $location . $_FILES["audio_file"]["name"]);

                        echo "Uploaded";

                    }

                }

            }

            else

            {

                echo "Invalid file";

            }

        }

        else{

            echo "LOGGEDOUT";

        }

	}

    

	function addTopicUpload(){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$topic_name = $this->input->post('topic_name');

			$topic_url = $this->input->post('topic_url');

			$file_name = $this->input->post('file_name');

			$file_name = preg_replace('/^.+\\\\/', '', $file_name);

			$file_type = $this->input->post('file_type');

			$topic_id = $this->addNewTopic($topic_name,$topic_url,$file_name);

//			$this->topic_model->addTopicUpload($topic_id, $file_name, $file_type);

		}

		else{

			echo "LOGGEDOUT";

		}

	}

    

    function addTopicDetailUpload(){

		if($this->session->userdata('is_logged_in') !== FALSE){			

			$topic_id = $this->input->post('topic_name');

			$file_name = $this->input->post('file_name');

			$file_type = $this->input->post('file_type');

			$this->topic_model->addTopicUpload($topic_id, $file_name, $file_type);

		}

		else{

			echo "LOGGEDOUT";

		}

	}

    

	function showGraph($is_encoded = "true", $duration = NULL, $graph_type = NULL, $patient_id = NULL){

		if($duration == NULL)

			$duration =  $this->input->post('graph_duration');

		if($graph_type == NULL)

			$graph_type = $this->input->post('graph_type');

		if($patient_id == NULL)

			$patient_id = $this->input->post('patient_id');

		$data['x_axis_tags'] = $this->patient_model->getXaxisTagsForGraph($duration, $patient_id);

		$data['y_axis_tags'] = $this->patient_model->getYaxisValuesForGraph($graph_type, $duration, $patient_id, $data['x_axis_tags']);

        

		if($graph_type == "pain_graph")			

			$data['title'] = "Average Pain Report";

		else if($graph_type == "sleep_graph")			

			$data['title'] = "Sleep Graph";

		else if($graph_type == "mood_graph")			

			$data['title'] = "Average Weight";

		else if($graph_type == "activity_graph")			

			$data['title'] = "Average Activity Interferences";

		

		$x_axis_tags_count = count($data['x_axis_tags']);

		for($i = 0; $i < $x_axis_tags_count; $i++){

			if($duration == "week")

				$data['x_axis_tags'][$i] = date("d-M", strtotime($data['x_axis_tags'][$i]));

			if($duration == "month")

				$data['x_axis_tags'][$i] = date("d-M", strtotime($data['x_axis_tags'][$i]));

			if($duration == "year")

				$data['x_axis_tags'][$i] = date("M-Y", strtotime($data['x_axis_tags'][$i]));

			if($duration == "all")

				$data['x_axis_tags'][$i] = date("d-M-Y", strtotime($data['x_axis_tags'][$i]));

		}

		if(	(count($data['x_axis_tags']) == 2) && ($data['x_axis_tags'][0] == $data['x_axis_tags'][1])	)

			$data['x_axis_tags'][1] = date("d-M-Y", mktime(0, 0, 0, date("m", strtotime($data['x_axis_tags'][0])), date("d", strtotime($data['x_axis_tags'][0])) + 1, date("Y", strtotime($data['x_axis_tags'][0]))));

		$data['is_encoded'] = $is_encoded;

		$this->load->view('patient-graph', $data);

	}

	/*function showGraph($is_encoded = "true", $duration = NULL, $graph_type = NULL, $patient_id = NULL){

        $time = 2;

		if(isset($_GET['duration'])){

			$time = $_GET['duration'];

		}

		if (!empty($patient_id)){

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

			// for reports average weight

			$bmi = 0;

			if($data['selected_patient_data'][0]->current_height != 0){

				$bmi = round(($data['selected_patient_data'][0]->current_weight/pow($data['selected_patient_data'][0]->current_height,2)),2);

			}

			

			$average_weight = '';

			if($data['selected_patient_data'][0]->current_height != 0){

				$weight = round(pow($data['selected_patient_data'][0]->current_height,2),2)*24.9;

				$weight2 = round(pow($data['selected_patient_data'][0]->current_height,2),2)*18.5;

				$average_weight = round((($weight+$weight2)/2),2);

			}

			$data['average_weight'] = '';

			if($bmi >18.5 && $bmi <24.9){

				$data['average_weight'] = $data['selected_patient_data'][0]->current_weight;

			} else {

				$data['average_weight'] = $average_weight;				

			}

			// for reports average weight

			

			$reports = array();

			$index = 0;

			$result = $this->patient_model->getReports($patient_id,$time);

			foreach($result as $row){

				if(!empty($row['entered_at'])){

					$reports[$index]['date'] = date('Y-m-d', $row['entered_at']);

					$reports[$index]['value'] = $row['weight'];

					$index++;

				}

			}

			

			// for reports average weight

			$data['start_date'] = date("Y-m-d");			

			$data['end_date'] = date("Y-m-d", (time()-WEEK));

			if($time != 1){

				$data['end_date'] = date("Y-m-d", (time()-MONTH));

			}

			// for reports average weight

			if(!empty($reports)){

				$data['jsonData'] = json_encode($reports);

			}            

		}

		$data['is_encoded'] = $is_encoded;

		$this->load->view('patient-graph', $data);

	}*/

    

    function showXValueGraph($is_encoded = "true", $duration = NULL, $graph_type = NULL, $patient_id = NULL){

		if($duration == NULL)

			$duration =  $this->input->post('graph_duration');

		if($graph_type == NULL)

			$graph_type = $this->input->post('graph_type');

		if($patient_id == NULL)

			$patient_id = $this->input->post('patient_id');

		$data['x_axis_tags'] = $this->patient_model->getXaxisTagsForGraph($duration, $patient_id);

		

		$x_axis_tags_count = count($data['x_axis_tags']);

		for($i = 0; $i < $x_axis_tags_count; $i++){

			if($duration == "week")

				$data['x_axis_tags'][$i] = date("d-M", strtotime($data['x_axis_tags'][$i]));

			if($duration == "month")

				$data['x_axis_tags'][$i] = date("d-M", strtotime($data['x_axis_tags'][$i]));

			if($duration == "year")

				$data['x_axis_tags'][$i] = date("M-Y", strtotime($data['x_axis_tags'][$i]));

			if($duration == "all")

				$data['x_axis_tags'][$i] = date("d-M-Y", strtotime($data['x_axis_tags'][$i]));

		}

		if(	(count($data['x_axis_tags']) == 2) && ($data['x_axis_tags'][0] == $data['x_axis_tags'][1])	)

			$data['x_axis_tags'][1] = date("d-M-Y", mktime(0, 0, 0, date("m", strtotime($data['x_axis_tags'][0])), date("d", strtotime($data['x_axis_tags'][0])) + 1, date("Y", strtotime($data['x_axis_tags'][0]))));

		

		$xvalue = "";

        for ($i = 0; $i < count($data['x_axis_tags']); $i++) {

            $xvalue .=  "<div class='s_buttons4'><a id='pain_graph_".$i."' onclick='getMonthResult(this);'>".$data['x_axis_tags'][$i]."</a></div>";

        }

        

        echo "<div id='graph-buttons'>".$xvalue."</div>";

        

	}

    

    function showXValueMonthGraph($is_encoded = "true", $duration = NULL, $graph_type = NULL, $patient_id = NULL){

		if($duration == NULL)

			$duration =  $this->input->post('graph_duration');

		if($graph_type == NULL)

			$graph_type = $this->input->post('graph_type');

		if($patient_id == NULL)

			$patient_id = $this->input->post('patient_id');

		$data['x_axis_tags'] = $this->patient_model->getXaxisTagsForMonthGraph($duration, $patient_id);

		

		$x_axis_tags_count = count($data['x_axis_tags']);

		for($i = 0; $i < $x_axis_tags_count; $i++){

				$data['x_axis_tags'][$i] = date("d-M", strtotime($data['x_axis_tags'][$i]));

		}

		if(	(count($data['x_axis_tags']) == 2) && ($data['x_axis_tags'][0] == $data['x_axis_tags'][1])	)

			$data['x_axis_tags'][1] = date("d-M-Y", mktime(0, 0, 0, date("m", strtotime($data['x_axis_tags'][0])), date("d", strtotime($data['x_axis_tags'][0])) + 1, date("Y", strtotime($data['x_axis_tags'][0]))));

		

		$xvalue = "";

        for ($i = 0; $i < count($data['x_axis_tags']); $i++) {

            $xvalue .=  "<div class='s_buttons4'><a id='pain_graph_".$i."' onclick='getMonthResult(this);'>".$data['x_axis_tags'][$i]."</a></div>";

        }

        

        echo "<div id='graph-buttons'>".$xvalue."</div>";

        

	}

    function showMonthGraph($is_encoded = "true", $duration = NULL, $graph_type = NULL, $patient_id = NULL){

		

        if($duration == NULL)

			$duration =  $this->input->post('graph_duration');

		if($graph_type == NULL)

			$graph_type = $this->input->post('graph_type');

		if($patient_id == NULL)

			$patient_id = $this->input->post('patient_id');

        

        $data['x_axis_tags'] = $this->patient_model->getXaxisTagsForMonthGraph($duration, $patient_id);

		$data['y_axis_tags'] = $this->patient_model->getYaxisValuesForGraph($graph_type, "month", $patient_id, $data['x_axis_tags']);

        

		if($graph_type == "pain_graph")			

			$data['title'] = "Average Pain Report";

		else if($graph_type == "sleep_graph")			

			$data['title'] = "Sleep Rating";

		else if($graph_type == "mood_graph")			

			$data['title'] = "Average Mood";

		else if($graph_type == "activity_graph")			

			$data['title'] = "Average Activity Interferences";

		

		$x_axis_tags_count = count($data['x_axis_tags']);

		for($i = 0; $i < $x_axis_tags_count; $i++){

			$data['x_axis_tags'][$i] = date("d-M", strtotime($data['x_axis_tags'][$i]));

		}

        

		if(	(count($data['x_axis_tags']) == 2) && ($data['x_axis_tags'][0] == $data['x_axis_tags'][1])	)

			$data['x_axis_tags'][1] = date("d-M-Y", mktime(0, 0, 0, date("m", strtotime($data['x_axis_tags'][0])), date("d", strtotime($data['x_axis_tags'][0])) + 1, date("Y", strtotime($data['x_axis_tags'][0]))));

		$data['is_encoded'] = $is_encoded;

		$this->load->view('patient-graph', $data);    

	}

    

	function getGraphImageByCurlCall($url){

		$ch = curl_init();

        

		curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);

		curl_setopt($ch, CURLOPT_HEADER, 0);

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

		curl_setopt($ch, CURLOPT_URL, $url);

		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);

		$data = curl_exec($ch);

		curl_close($ch);

        

		return $data;

	}

    

	function generateReport($patient_id,$time){

		//$data['pain_graph'] = file_get_contents(asset_url() . "images/brigham_logo1.png");

		//echo($data['pain_graph']);

		

        if($this->session->userdata('is_logged_in') !== FALSE){

			$data['patient_data'] = $this->patient_model->getPatientDataforReport($patient_id);

			//$data['pain_graph'] =  $this->showGraph("false", "all", "pain_graph", $patient_id);

			//$data['pain_graph'] =  $this->getGraphImageByCurlCall(site_url('patient/showGraph/false/all/pain_graph') . "/". $patient_id);

			

            //$data['sleep_graph'] = $this->getGraphImageByCurlCall(site_url('patient/showGraph/false/all/sleep_graph') . "/". $patient_id);

			$data['selected_patient_weight_data'] = $this->patient_model->getReportsArray($patient_id,$time);



			//$data['mood_graph'] = $this->getGraphImageByCurlCall(site_url('patient/showGraph/false/all/mood_graph') . "/". $patient_id);

		//	$data['activity_graph'] = $this->getGraphImageByCurlCall(site_url('patient/showGraph/false/all/activity_graph') . "/". $patient_id);

         //   $data['selected_patient_userevaluation_data'] = $this->patient_model->getPatientUserEvaluationDataById($patient_id);

			//var_dump($data['current_medication']);

			$this->load->view('patient-report', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

    function exportData($patient_id =NULL){
        if ($this->session->userdata('is_logged_in') !== FALSE) { 

            $config['base_url'] = site_url('patient/topic_of_interest')."/".$patient_id;

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

             $data['selected_patient_data'] = $this->getPatientDataById($patient_id);

             $data['selected_patient_id'] = $patient_id;
			
			$searchOnData = $this->uri->segment(4);
			
			//echo ($searchOnData);
			
            $data['all_patient_rows'] = $this->patient_model->getAllPatient($searchOnData);
			
			if(!empty($data['all_patient_rows'])){
				$data['all_patient_rows'] = json_decode(json_encode($data['all_patient_rows']), True);
				
				$list = $data['all_patient_rows'];
				if(!empty($list)){
					foreach($list as $key=>$info){
						if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
							unset($list[$key]);
						}else {
							$list[$key] = (object)$info;
						}
					}
					$list = array_values($list);
				}
				unset($data['all_patient_rows']); // $foo is gone
				$data['all_patient_rows'] = array(); // $foo is here again
				$data['all_patient_rows'] = $list;
				
				//print_r($list);
			}
			
		
            $this->load->view('exportPatientData', $data);

        } else {

            $this->load->view('login_form');

        }

    }

    

    function getExportData($patient_list =NULL){

        if ($this->session->userdata('is_logged_in') !== FALSE) {

            $this->load->helper('download');

            $this->load->library('zip');

//            $data = $this->patient_model->getInitialPatientDataCSV(explode('%20', $patient_list));

 //           $name = 'inital.csv';

//            $this->zip->add_data($name, $data);

 //           $data = $this->patient_model->getDailyPatientDataCSV(explode('%20', $patient_list));

  //          $name = 'daily.csv';



//            $this->zip->add_data($name, $data);
			   $data = $this->patient_model->getPatients(explode('%20', $patient_list));

			   $name = 'patient.csv';


				
				$this->zip->add_data($name, $data);

				$this->zip->download('report.zip');
        } else {

            $this->load->view('login_form');

        }
    }
	
	function deleteNonRegisterPatients($patient_list =NULL){

        if ($this->session->userdata('is_logged_in') !== FALSE) {
			$data = $this->patient_model->deletePatients(explode('%20', $patient_list));
			redirect('patient/non_registered/delete');
        } 
		else 
		{
		   $this->load->view('login_form');
        }
    }

	function deletePatients($patient_list =NULL){

        if ($this->session->userdata('is_logged_in') !== FALSE) {
			    
				$data = $this->patient_model->deletePatients(explode('%20', $patient_list));
				if( $this->uri->segment(3) == "1" )
			    {
				   	redirect('patient/non_registered/delete');
			    }
				else
				{
					redirect('patient/showDashboard/delete');
				}			   
        } 
		else 
		{
		   $this->load->view('login_form');
        }
    }
    

    function add_appointments($patient_id = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$config['base_url'] = site_url('patient/topic_of_interest')."/".$patient_id;

			$data['all_patient_data'] =  $this->patient_model->getPatientDataAll();
			if(!empty($data['all_patient_data'])){
				$data['all_patient_data'] = json_decode(json_encode($data['all_patient_data']), True);
				
				$list = $data['all_patient_data'];
				if(!empty($list)){
					foreach($list as $key=>$info){
						if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
							unset($list[$key]);
						}else {
							$list[$key] = (object)$info;
						}
					}
					$list = array_values($list);
				}
				unset($data['all_patient_data']); // $foo is gone
				$data['all_patient_data'] = array(); // $foo is here again
				$data['all_patient_data'] = $list;
			}
			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

			$data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_id'] = $patient_id;

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();
			
			$data['users_appointments'] = $this->patient_model->getAppointmentsList();

			if(!empty($patient_id)){

				$result = $this->patient_model->searchAppointment($patient_id);

				$data['appointment_list'] = array();

				$index = 0;

				if(!empty($result)){

					foreach($result as $row){

						$data['appointment_list'][$index]['id'] = $row->id;

						$data['appointment_list'][$index]['patient_id'] = $row->patient_id;

						$data['appointment_list'][$index]['notes'] = $row->notes;

						$data['appointment_list'][$index]['doctor_name'] = $row->doctor_name;

						$data['appointment_list'][$index]['date'] = formatDateCustom($row->time,'stamp');
						
						$data['appointment_list'][$index]['time'] = date('H:i:s a',$row->time);

						$data['appointment_list'][$index]['user_first_name'] = $row->user_first_name;

						$data['appointment_list'][$index]['user_last_name'] = $row->user_last_name;

						$index++;

					}

				}

			}

			$this->load->view('add_appointment',$data);

		}

		else{

			$this->load->view('login_form');

		}

	}
    
    function appointment_list($patient_id = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){



//			$patientID = $this->input->post('patientList');

//			$patientID = explode("_", $patientID);

			$config['base_url'] = site_url('patient/topic_of_interest')."/".$patient_id;

			$data['all_patient_data'] =  $this->patient_model->getPatientDataAll();
			if(!empty($data['all_patient_data'])){
				$data['all_patient_data'] = json_decode(json_encode($data['all_patient_data']), True);
				
				$list = $data['all_patient_data'];
				if(!empty($list)){
					foreach($list as $key=>$info){
						if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
							unset($list[$key]);
						}else {
							$list[$key] = (object)$info;
						}
					}
					$list = array_values($list);
				}
				unset($data['all_patient_data']); // $foo is gone
				$data['all_patient_data'] = array(); // $foo is here again
				$data['all_patient_data'] = $list;
			}
			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);

			$data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_id'] = $patient_id;

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();


			if(!empty($patient_id)){

				$result = $this->patient_model->searchAppointment($patient_id);
			}
			else
			{
				$result = $this->patient_model->AllAppointmentToday();
			}			

			if( true ){

				//$result = $this->patient_model->searchAppointment($patient_id);

				$data['appointment_list'] = array();

				$index = 0;

				if(!empty($result)){

					foreach($result as $row){

						$data['appointment_list'][$index]['id'] = $row->id;

						$data['appointment_list'][$index]['patient_id'] = $row->patient_id;

						$data['appointment_list'][$index]['notes'] = $row->notes;

						$data['appointment_list'][$index]['doctor_name'] = $row->doctor_name;

						$data['appointment_list'][$index]['date'] = formatDateCustom($row->time,'stamp');
						
						$data['appointment_list'][$index]['time'] = date('h:i:s a',$row->time);

						$data['appointment_list'][$index]['user_first_name'] = $row->user_first_name;

						$data['appointment_list'][$index]['user_last_name'] = $row->user_last_name;

						$index++;

					}

				}

			}

			$this->load->view('appointment_list',$data);

		}

		else{

			$this->load->view('login_form');

		}

	}

    function addMedicationLink(){

        if ($this->session->userdata('is_logged_in') !== FALSE) {

            

           $_title = $this->input->post('title');

            $_link = $this->input->post('link');

            

            echo($_link." : ".$_title);

            $this->patient_model->addMedicationLink($_link, $_title);

            }

		else{

			echo "LOGGEDOUT";

		}

	}

    function set_appointment(){

        if ($this->session->userdata('is_logged_in') !== FALSE) {

            $reqID = $this->input->post('reqID');
			
			$_pID = $this->input->post('patientID');

            $_fromDate = $this->input->post('fromDate');

            $dr_name = $this->input->post('dr_name');

            $notes = $this->input->post('notes');

//            $_toDate = $this->input->post('toDate');
            

            $this->patient_model->saveAppointment($_pID, $_fromDate, $dr_name, $notes , $reqID );

            callSendMessageAPIDelay($_pID,"You have a appoinment now.","appoinment",$_fromDate);

		}

		else{

			echo "LOGGEDOUT";

		}

	}

    function removeAppointment(){

        if ($this->session->userdata('is_logged_in') !== FALSE) {

            

            $_ID = $this->input->post('rem_id');

            

            $this->patient_model->removeAppointment($_ID);

            

		}

		else{

			echo "LOGGEDOUT";

		}

    }


    function search_appointment(){

        if ($this->session->userdata('is_logged_in') !== FALSE) {

            

            $_ID = $this->input->post('search_id');

            

            $result = $this->patient_model->searchAppointment($_ID);

			$appointment_list = array();

			$index = 0;

			if(!empty($result)){

				foreach($result as $row){

					$appointment_list[$index]['id'] = $row->id;

					$appointment_list[$index]['patient_id'] = $row->patient_id;

					$appointment_list[$index]['notes'] = $row->notes;

					$appointment_list[$index]['doctor_name'] = $row->doctor_name;

					$appointment_list[$index]['time'] = date('d-m-Y h:i:s a',$row->time);

					$appointment_list[$index]['user_first_name'] = $row->user_first_name;

					$appointment_list[$index]['user_last_name'] = $row->user_last_name;

					$index++;

				}

			}

			echo json_encode($appointment_list);

		}

		else{

			echo "LOGGEDOUT";

		}

    }

    function AllAppointmentToday(){

        if ($this->session->userdata('is_logged_in') !== FALSE) {

            $result = $this->patient_model->AllAppointmentToday();

			$appointment_list = array();

			$index = 0;

			if(!empty($result)){

				foreach($result as $row){

					$appointment_list[$index]['id'] = $row->id;

					$appointment_list[$index]['patient_id'] = $row->patient_id;

					$appointment_list[$index]['notes'] = $row->notes;

					$appointment_list[$index]['doctor_name'] = $row->doctor_name;

					$appointment_list[$index]['date'] = formatDateCustom($row->time,'stamp');
					
					$appointment_list[$index]['time'] = date('H:i:s a',$row->time);

					$appointment_list[$index]['user_first_name'] = $row->user_first_name;

					$appointment_list[$index]['user_last_name'] = $row->user_last_name;

					$index++;

				}

			}

			echo json_encode($appointment_list);

		}

		else{

			echo "LOGGEDOUT";

		}

    }

    function goal_list($patient_id = NULL){

		if($this->session->userdata('is_logged_in') !== FALSE){

			$config['base_url'] = site_url('patient/topic_of_interest')."/".$patient_id;

            $data['all_patient_rows'] = $this->patient_model->getAllPatient();

            if(!empty($data['all_patient_rows'])){
				$data['all_patient_rows'] = json_decode(json_encode($data['all_patient_rows']), True);
				
				$list = $data['all_patient_rows'];
				if(!empty($list)){
					foreach($list as $key=>$info){
						if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
							unset($list[$key]);
						}else {
							$list[$key] = (object)$info;
						}
					}
					$list = array_values($list);
				}
				unset($data['all_patient_rows']); // $foo is gone
				$data['all_patient_rows'] = array(); // $foo is here again
				$data['all_patient_rows'] = $list;
			}

            $data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_id'] = $patient_id;

			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			

			if(!empty($patient_id)){

				$data['goals'] = $this->patient_model->getAllGoal($patient_id);

			}

			

			$this->load->view('goal', $data);

		}

		else{

			$this->load->view('login_form');

		}

	}

    

    function get_goal(){

        

        if ($this->session->userdata('is_logged_in') !== FALSE) {

            

            $patientID = $this->input->post('patientList');

            $data = $this->patient_model->getAllGoal($patientID);

            echo json_encode($data);

            

            //$patientID = explode("_", $patientID);

            //echo $patientID[0];

            /*

            $data['all_goals_rows'] = $this->patient_model->getAllGoal($patientID);

            

            $config['base_url'] = site_url('patient/topic_of_interest')."/".$this->uri->segment(3);

            $data['all_patient_rows'] = $this->patient_model->getAllPatient();

            

            $data['selected_patient_data'] = $this->getPatientDataById($this->uri->segment(3));

            $data['selected_patient_message'] = $this->getPatientMessageCount($this->uri->segment(3));

			$data['selected_patient_id'] = $this->uri->segment(3);

            $data['goals_id'] = $patientID[1];

            

			$this->load->view('goal', $data);

            */

		}

		else{

			echo "LOGGEDOUT";

		}

	}

     

    /*function report_list($patient_id = NULL){

         

       if($this->session->userdata('is_logged_in') !== FALSE){

            

            $patientID = $this->input->post('patientList');

            $patientID = explode("_", $patientID);

            $data['all_reports_rows'] = $this->patient_model->getAllReports();

            

            foreach ($data['all_reports_rows'] as $row) {

                

                $patientData = $this->getPatientDataById(intval($row->patient_id));

                

                if(isset($patientData[0]->user_name)){

                    $row->patient_name = $patientData[0]->user_name;

                }

            }

            $config['base_url'] = site_url('patient/topic_of_interest')."/".$patient_id;

            $data['all_patient_rows'] = $this->patient_model->getAllPatient();

            

            $data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_id'] = $patient_id;

            

			$this->load->view('report', $data);

		}

		else{

			echo "LOGGEDOUT";

		}

	}*/

    function report_list($patient_id = NULL){
        $time = 1;
		$data['is_tab1'] = true;
		if(isset($_GET['duration'])){

			$time = $_GET['duration'];

		}

       if($this->session->userdata('is_logged_in') !== FALSE){
			//echo "Working on the graph";
			//exit;
            $data['all_patient_rows'] = $this->patient_model->getAllPatient();
		
			$data['all_patient_data'] =  $this->patient_model->getPatientDataAll();
			if(!empty($data['all_patient_data'])){
				$data['all_patient_data'] = json_decode(json_encode($data['all_patient_data']), True);
				//print_r($data['all_patient_data']); die();
				$list = $data['all_patient_data'];
				if(!empty($list)){
					foreach($list as $key=>$info){
						if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
							unset($list[$key]);
						}else {
							$list[$key] = (object)$info;
						}
					}
					$list = array_values($list);
				}
				unset($data['all_patient_data']); // $foo is gone
				$data['all_patient_data'] = array(); // $foo is here again
				$data['all_patient_data'] = $list;
			}
			$data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_id'] = $patient_id;

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);
			//print_r($data['selected_patient_data']); die();
			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			$data['jsonData'] = '';	

			if (!empty($data['selected_patient_data'])){

				// for reports average weight

				$bmi = 0;

				if($data['selected_patient_data'][0]->current_height != 0){

					$bmi = round(($data['selected_patient_data'][0]->current_weight/pow($data['selected_patient_data'][0]->current_height,2)),2);

				}

				

				$average_weight = '';

				if($data['selected_patient_data'][0]->current_height != 0){

					$weight = round(pow($data['selected_patient_data'][0]->current_height,2),2)*24.9;

					$weight2 = round(pow($data['selected_patient_data'][0]->current_height,2),2)*18.5;

					$average_weight = round((($weight+$weight2)/2),2);

				}

				$data['average_weight'] = '';

				if($bmi >18.5 && $bmi <24.9){

					$data['average_weight'] = $data['selected_patient_data'][0]->current_weight;

				} else {

					$data['average_weight'] = $average_weight;				

				}

				// for reports average weight

				$result = $this->patient_model->getReports($patient_id,$time);
				//print_r($result); die();

				// for reports average weight

				$data['start_date'] = date("Y-m-d");			

				$data['end_date'] = date("Y-m-d", (time()-WEEK));

				if($time != 1){

					$data['end_date'] = date("Y-m-d", (time()-MONTH));

				}

				$timestamp = time();

				$last_days = array();

				$index = 0;

				if($time == 1){

					for ($i = 0 ; $i < 7 ; $i++) {

						$last_days[$index] = date('Y-m-d', $timestamp);

						$timestamp -= 24 * 3600;

						$index++;

					}

				}

				if($time == 2){

					for ($i = 0 ; $i < 30 ; $i++) {

						$last_days[$index] = date('Y-m-d', $timestamp);

						$timestamp -= 24 * 3600;

						$index++;

					}

				}

				

				

				$reports = array();

				$index = 0;
				//print_r($last_days);
				$weight_entered_at = array();
				$weight_value = array();
				if(!empty($result)){
					$weight_entered_at = array_values(array_column($result, 'entered_at'));  
					$weight_value = array_values(array_column($result, 'weight'));  
					array_walk($weight_entered_at, function(&$date, $i, $formats)
					{
						$date = date('Y-m-d', $date);
					},[]);
				}
				$final_array = array_combine($weight_entered_at,$weight_value);
				for($i=0;$i<count($last_days);$i++){
					if(array_key_exists($last_days[$i],$final_array)){
						$reports[$i]['date'] = $last_days[$i];
						$reports[$i]['distance'] = $final_array[$last_days[$i]];
					}else{
						$reports[$i]['date'] = $last_days[$i];
						$reports[$i]['distance'] = 0;
					}
					/* foreach($result as $row){
						
						if($last_days[$i] == date('Y-m-d', $row['entered_at'])){
							//echo date('Y-m-d', $row['entered_at']); die();
							$reports[$index]['date'] = date('Y-m-d', $row['entered_at']);

							$reports[$index]['distance'] = $row['weight'];						

						}

						else{

							$reports[$index]['date'] = $last_days[$i];

							$reports[$index]['distance'] = 0;

						}

						$index++;

					} */

				}
				//print_r($reports); die();
				uasort($reports, 'cmp');



				$charts = array();

				$charts_index = 0;

				foreach($reports as $chart){

					$charts[$charts_index]['date'] = $chart['date'];

					$charts[$charts_index]['distance'] = $chart['distance'];						

					$charts_index++;

				}

				

				// for reports average weight
				if(!empty($charts)){

					$data['jsonData'] = json_encode($charts);
				}



			}
			
			if( $time == 1)
			{
				$currentDate1 = date("Y-m-d" , strtotime("-7 Days") );
				$currentDate = date("Y-m-d");

				$from = date("Y-m-d 00:00:00" , strtotime("-7 Days") );
				$to = date("Y-m-d 23:59:59");
			}

			if( $time == 2)
			{
				$currentDate1 = date("Y-m-01");
				$currentDate = date("Y-m-d");

				$from = date("Y-m-01 00:00:00");
				$to = date("Y-m-d 23:59:59");
			}
			
			$from = (isset($_GET['date']))?$_GET['date']:date('m/d/Y');
			$to = (isset($_GET['to_date']))?$_GET['to_date']:date('m/d/Y');
			
			$from = strtotime($from . " 00:00:00");
			$to = strtotime($to. " 23:59:59");
			
			if( !empty($patient_id) ) {
				$whereCond = "";
				$whereCond .= " entered_at BETWEEN '$from' AND '$to' ";
				$whereCond .= " AND user_info.id IN ($patient_id) ";
				
				//$last_date = strtotime("+ 7 days",$first_date);
				
				$userBasicInfo = $this->patient_model->getUsersBasicInfo("user_info.id IN ($patient_id)");
				//print_r($userBasicInfo);
				
				$datesVals = $this->patient_model->getDatesListOnDemVal( $currentDate1 , $currentDate , "86400");
				$graphData = $this->patient_model->getWeightGraphData($whereCond , $datesVals);
				
				$data["high_charts_dates"] = $graphData[0];
				$data["high_charts_data"] = $graphData[1];
				$data["userBasicInfo"] = $userBasicInfo[$patient_id];
			}
			
			$this->load->view('report', $data);

		}

		else{

			echo "LOGGEDOUT";

		}

	}
	
	
	function diet_report($patient_id = NULL){
        $time = 1;
		$data['is_tab2'] = true;
       if($this->session->userdata('is_logged_in') !== FALSE){

            

            $data['all_patient_rows'] = $this->patient_model->getAllPatient();
		
			$data['all_patient_data'] =  $this->patient_model->getPatientDataAll();
			if(!empty($data['all_patient_data'])){
				$data['all_patient_data'] = json_decode(json_encode($data['all_patient_data']), True);
				//print_r($data['all_patient_data']); die();
				$list = $data['all_patient_data'];
				if(!empty($list)){
					foreach($list as $key=>$info){
						if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
							unset($list[$key]);
						}else {
							$list[$key] = (object)$info;
						}
					}
					$list = array_values($list);
				}
				unset($data['all_patient_data']); // $foo is gone
				$data['all_patient_data'] = array(); // $foo is here again
				$data['all_patient_data'] = $list;
			}
			$data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_id'] = $patient_id;

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);
			//print_r($data['selected_patient_data']); die();
			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			
			$data['jsonDietData'] = "";

			if (!empty($data['selected_patient_data'])){

				$date = (isset($_GET['date']))?$_GET['date']:date('m/d/Y');
				$dietResult = $this->patient_model->getDietReports($patient_id,$date);
				$dietResultArray = json_decode(json_encode($dietResult), True);
				//print_r($result); die();
				
				// for reports average weight
				if(!empty($dietResultArray)){
					$data['jsonDietData'] = json_encode($dietResultArray);
				}

				$date = date("Y-m-d");
				$to_date =  date("Y-m-d");
				
				if(isset($_GET['date']))
				{
					$date = $_GET['date'];
					$to_date = $_GET['to_date'];
				}
				
				$from = strtotime($date . " 00:00:00");
				$to = strtotime($to_date . " 23:59:59");
				
				$data["total"] = 0;
				$data["daily_diet_gloal"] = 0;
				
				if( !empty($patient_id) ) {
	
					$whereCond = "";
					$whereCond .= " created_at BETWEEN '$from' AND '$to' ";
					$whereCond .= " AND user_id IN ($patient_id) ";
	
					$graphData = $this->patient_model->getDietGraphData( $whereCond , " user_id IN ($patient_id) AND goal_type = '3' ");
					
					$data["total"] =  (!empty($graphData[2]) ? $graphData[2] : 0);
					$data["high_charts_data"] =  $graphData[0];
					$data["daily_diet_gloal"] =  (!empty($graphData[1][0]["goal_data"]) ? $graphData[1][0]["goal_data"] : 0);
				}
			}

			$this->load->view('diet_report', $data);

		}

		else{

			echo "LOGGEDOUT";

		}

	}
	
	function exercise_report($patient_id = NULL){
        $time = 1;
		$data['is_tab3'] = true;
       if($this->session->userdata('is_logged_in') !== FALSE){

            

            $data['all_patient_rows'] = $this->patient_model->getAllPatient();
		
			$data['all_patient_data'] =  $this->patient_model->getPatientDataAll();
			if(!empty($data['all_patient_data'])){
				$data['all_patient_data'] = json_decode(json_encode($data['all_patient_data']), True);
				//print_r($data['all_patient_data']); die();
				$list = $data['all_patient_data'];
				if(!empty($list)){
					foreach($list as $key=>$info){
						if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
							unset($list[$key]);
						}else {
							$list[$key] = (object)$info;
						}
					}
					$list = array_values($list);
				}
				unset($data['all_patient_data']); // $foo is gone
				$data['all_patient_data'] = array(); // $foo is here again
				$data['all_patient_data'] = $list;
			}
			$data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_id'] = $patient_id;

			$data['selected_patient_data'] = $this->getPatientDataById($patient_id);
			//print_r($data['selected_patient_data']); die();
			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();

			
			$data['jsonDietData'] = "";

			if (!empty($data['selected_patient_data'])){

				$date = (isset($_GET['date']))?$_GET['date']:date('m/d/Y');
				$dietResult = $this->patient_model->getExerciseReports($patient_id,$date);
				$dietResultArray = json_decode(json_encode($dietResult), True);
				if(!empty($dietResultArray)){
					array_walk($dietResultArray, function(&$date, $i, $formats)
					{
						//print_r($date); die();
						$final_duration = "";
						$hours = floor($date['duration'] / 3600);
						$mins = gmdate("i", $date['duration']);
						if($hours!=0){ $final_duration .= ($hours>1)?$hours." hrs ":$hours." hr "; }
						if($hours!=0 && $hours<10){ $final_duration = "0".$final_duration; }
						if($mins!=0){ $final_duration .= ($mins>1)?$mins." mins":$mins." min"; }
						$date['hours'] = $final_duration." at ".date("h:i a", $date['created_at']);
						$date['duration'] =  floor($date['duration'] / 3600);
					},[]);
				} 
				//print_r($dietResultArray); die();
				
				// for reports average weight
				if(!empty($dietResultArray)){
					$data['jsonDietData'] = json_encode($dietResultArray);
				}
			}

			$date = date("Y-m-d");
			$to_date =  date("Y-m-d");
			
			if(isset($_GET['date']))
			{
				$date = $_GET['date'];
				$to_date = $_GET['to_date'];
			}
			
			if(isset($_GET['duration'])){
				$time = $_GET['duration'];

				if( $time == 1)
				{
					$currentDate1 = date("Y-m-d" , strtotime("-7 Days") );
					$currentDate = date("Y-m-d");
	
					$from = date("Y-m-d 00:00:00" , strtotime("-7 Days") );
					$to = date("Y-m-d 23:59:59");
				}
				
				if( $time == 2)
				{
					$currentDate1 = date("Y-m-01");
					$currentDate = date("Y-m-d");
	
					$from = date("Y-m-01 00:00:00");
					$to = date("Y-m-d 23:59:59");
				}
			}
			else
			{
					$from = "$date 00:00:00";
					$to = "$to_date 23:59:59";
			}
			
			//echo $from;
			//echo "<br>";
			//echo $to;
			
			$from = strtotime($from);
			$to = strtotime($to);
			
			if( !empty($patient_id) ) {

				$whereCond = "";
				$whereCond .= " created_at BETWEEN '$from' AND '$to' ";
				$whereCond .= " AND user_info.id IN ($patient_id) ";

				$graphData = $this->patient_model->getExerciseGraphData( $whereCond );

				$data["high_charts_dates"] = $graphData[0];
				$data["high_charts_data"] =  $graphData[1];
			}
			
				$this->load->view('exercise_report', $data);
		}
		else{
			echo "LOGGEDOUT";
		}
	}

    function medication_link($patient_id = NULL){

         

       if($this->session->userdata('is_logged_in') !== FALSE){

            $patientID = $this->input->post('patientList');

            $patientID = explode("_", $patientID);

            $config['base_url'] = site_url('patient/topic_of_interest')."/".$patient_id;

            $data['all_medication_rows'] = $this->patient_model->getAllMedicationLink();

             $data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

			$data['selected_patient_id'] = $patient_id;

            $this->load->view('medicationLink', $data);

	}

	else{

            echo "LOGGEDOUT";

	}

    }

    function selfAssesment($patient_id = NULL){

         

       if($this->session->userdata('is_logged_in') !== FALSE){

            $patientID = $this->input->post('patientList');

            $patientID = explode("_", $patientID);

            $config['base_url'] = site_url('patient/topic_of_interest')."/".$patient_id;

            $data['soapp_data'] = $this->patient_model->getALlSoappRecordByPatient();

            $data['comm_data'] = $this->patient_model->getALlCOMMRecordByPatient();

            $data['opiod_data'] = $this->patient_model->getALlOPIODRecordByPatient();

            $data['selected_patient_data'] = $this->getPatientDataById($patient_id);

            $data['selected_patient_message'] = $this->getPatientMessageCount($patient_id);

            $data['selected_patient_id'] = $patient_id;

            $this->load->view('selfAssesstment', $data);

	}

	else{

            echo "LOGGEDOUT";

	}

    }

    function upload_content_file_report() {

		if($this->session->userdata('is_logged_in') !== FALSE) {

			$allowedExts = array("gif", "jpeg", "JPG", "jpg", "png", "pdf","html", "htm");

			$temp = explode(".", $_FILES["content_file"]["name"]);

			$extension = end($temp);

			

            if ((($_FILES["content_file"]["type"] == "text/html"))

            || (($_FILES["content_file"]["type"] == "image/gif")

			|| ($_FILES["content_file"]["type"] == "image/jpeg")

			|| ($_FILES["content_file"]["type"] == "image/jpg")

			|| ($_FILES["content_file"]["type"] == "image/pjpeg")

			|| ($_FILES["content_file"]["type"] == "image/png")

			|| ($_FILES["content_file"]["type"] == "application/pdf")

			|| ($_FILES["content_file"]["type"] == "text/pdf")

			|| ($_FILES["content_file"]["type"] == "image/x-png")

            || ($_FILES["content_file"]["type"] == "text/html"))

			&& in_array($extension, $allowedExts))

            {

                if ($_FILES["content_file"]["error"] > 0)

                {

                    echo "Return Code: " . $_FILES["content_file"]["error"] . "<br>";

				}

                else

				{

				    $location = "'../../../uploads/report/";

//                    if (file_exists($location . $_FILES["content_file"]["name"]))

//                    {

//                        echo $_FILES["content_file"]["name"] . " already exists. ";

//                    }

//                    else

//                    {

                        $fullName = $location.date('YmdHis').'__'.$_FILES["content_file"]["name"];

                        move_uploaded_file($_FILES["content_file"]["tmp_name"], $fullName);

                        echo "Uploaded|".date('YmdHis').'__'.$_FILES["content_file"]["name"];



//                    }

                }

            }

            else {

                if ($temp[1] == "pdf") {

                    echo "file size issue";

                }

                else {

                    echo "Invalid file";

                }

            }

		}

		else{

			echo "LOGGEDOUT";

		}

	}

    

    function addReportDetailUpload() {

		if($this->session->userdata('is_logged_in') !== FALSE){			

			$topic_id = $this->input->post('pID');

			$file_name = $this->input->post('file_name');

			$this->patient_model->addReportUpload($topic_id, $file_name);

                        callSendMessageAPI($topic_id, "Report Uploaded","report");

		}

		else{

			echo "LOGGEDOUT";

		}

	}

    function removeLink(){

        if ($this->session->userdata('is_logged_in') !== FALSE) {

            $_ID = $this->input->post('id');

            $this->patient_model->removeLink($_ID);

		}

		else{

			echo "LOGGEDOUT";

		}

    }

    function removeReport(){

        if ($this->session->userdata('is_logged_in') !== FALSE) {

            $_ID = $this->input->post('rem_id');

            $this->patient_model->removeReport($_ID);

		}

		else{

			echo "LOGGEDOUT";

		}

    }
	
	function updatePassword()
	{
		$userName = $this->session->userdata('user_name');
	
		$oldPassword = urldecode(trim($_POST["oldPassword"]));
		$newPassword = urldecode(trim($_POST["newPassword"]));
		$confirmPassword = urldecode(trim($_POST["confirmPassword"]));
		$userPassword = urldecode($_POST["userPassword"]);
	
		if( $oldPassword == "" )
		{
			echo ("Please enter old password.");
			exit;
		}	

		if( $newPassword == "" )
		{
			echo ("Please enter new password.");
			exit;
		}	

		if( $confirmPassword == "" )
		{
			echo ("Please enter confirm password.");
			exit;
		}	
	
		$oldPassword = base64_url_encode(md5($oldPassword));
		
		if( $oldPassword != $userPassword )
		{
			echo ("Please enter a correct old password.");		
			exit;
		}

		if( $newPassword != $confirmPassword )
		{
			echo ("New password and confirm password not match.");		
			exit;
		}
		
		$result = $this->patient_model->updateUserPassword( $userName , $newPassword);
	
		if( $result )
		{
			echo "Password has been changed successfully";
			exit;
		}
	}

	function change_password()
	{
		  if($this->session->userdata('is_logged_in') !== FALSE)
		  {
			$data['total_rows'] = $this->patient_model->getPatientCombinedInboxMessageCount();
		  
		  	$userName = $this->session->userdata('user_name');
		  
			$config['base_url'] = site_url('patient/change_password');

			$data['userData'] = $this->patient_model->getUsersDetail($userName);

			$this->load->view('change_password', $data);
		}
		else
		{
				echo "LOGGEDOUT";
		}
	}	
}