<?php

class patient_model extends CI_Model {

    public function __construct() {
        parent::__construct();
        $this->checkAllHashedPatient();
    }
    
    function checkAllHashedPatient(){
        $this->db->select('id,user_first_name,user_last_name,patient_ref_no,date_of_birth,phone_number,email,password,isHashed');
        $this->db->where('isHashed', false);
        $query = $this->db->get('user_info')->result();
        if(isset($query) && count($query) > 0){
            foreach ($query as $row) {
                $this->db->where('id', $row->id);
                $this->db->update('user_info', array(
                    'user_first_name' => base64_url_encode($row->user_first_name),
                    'user_last_name' => base64_url_encode($row->user_last_name),
                    'patient_ref_no' => base64_url_encode($row->patient_ref_no),
                    'date_of_birth' => base64_url_encode($row->date_of_birth),
                    'phone_number' => base64_url_encode_custom($row->phone_number),
                    'email' => base64_url_encode_custom($row->email),
                    'password' => base64_url_encode($row->password),
                    'isHashed' => true
                ));
            }
        }
    }
    function getTotalPatientCount() {
        $this->db->select('count(id) as count')->from('user_info')->where("is_registered",1);;
        $query = $this->db->get()->result();
        return $query[0]->count;
    }
	
	function getTotalNonRegisteredPatientCount() {
        $this->db->select('count(id) as count')->from('user_info')->where("is_registered",0);
        $query = $this->db->get()->result();
        return $query[0]->count;
    }
    function checkHashValue($arr){
        if(isset($arr) && is_array($arr) && count($arr)>0 ){
            foreach ($arr as $row) {
                
                if(isset($row->user_first_name)) {
                    $row->user_first_name = ucfirst(preg_replace('/\s+/', '', base64_url_decode($row->user_first_name)));
                }
                if (isset($row->user_last_name)) {
                    $row->user_last_name = ucfirst(preg_replace('/\s+/', '', base64_url_decode($row->user_last_name)));
                }
                if (isset($row->patient_ref_no)) {
                    $row->patient_ref_no = base64_url_decode($row->patient_ref_no);
                }
                if (isset($row->date_of_birth)) {
                    $row->date_of_birth = base64_url_decode($row->date_of_birth);
                }
                if (isset($row->phone_number)) {
                    $row->phone_number = base64_url_decode($row->phone_number);
                }
               
                if (isset($row->email)) {
                    $row->email = base64_url_decode($row->email);
                }
                if (isset($row->password)) {
                    $row->password = base64_url_decode($row->password);
                }
            }
        }
        return $arr;
    }
    function checkHashValueNew($arr){
        if(isset($arr) && is_array($arr) && count($arr)>0 ){
            foreach ($arr as  &$row) {
                
                if(isset($row["user_first_name"])) {
                    
                    $row["user_first_name"] = ucfirst(preg_replace('/\s+/', '',base64_url_decode($row["user_first_name"])));
                    
                }
                if (isset($row["user_last_name"])) {
                    $row["user_last_name"] = preg_replace('/\s+/', '',ucfirst(base64_url_decode($row["user_last_name"])));
                }
                if (isset($row["patient_ref_no"])) {
                    $row["patient_ref_no"] = base64_url_decode($row["patient_ref_no"]);
                }
                if (isset($row["date_of_birth"])) {
                    $row["date_of_birth"] = base64_url_decode($row["date_of_birth"]);
                }
                if (isset($row["phone_number"])) {
                    $row["phone_number"] = base64_url_decode($row["phone_number"]);
                }
                
                if (isset($row["email"])) {
                    $row["email"] = base64_url_decode($row["email"]);
                }
                if (isset($row["password"])) {
                    $row["password"] = base64_url_decode($row["password"]);
                }
                
            }
        }
        
        return $arr;
    }
	
	function deleteUser($user_id){
		$qStr = "DELETE FROM user_info WHERE id='".$user_id."'";
		return $query = $this->db->query($qStr);
	}
	
	function addUser($data){
		
			return $this->db->insert('user_info', $data);
			
	}
	
	function checkUserExist($email){
		 $this->db->select('email');
		 $this->db->where("email",base64_url_encode($email));
		 return $list = $this->db->get('user_info')->row_array();
	}

	function checkDupplicateUser( $fieldValue = "" , $fieldChk = "" ){
	
		$fieldValue = base64_url_encode($fieldValue);
		
		$whereCond  = "";
		
		if( $fieldChk == "Email" )
		{
			$fieldValue = str_replace( "," , "=" ,$fieldValue);
			
			$whereCond = " email = '$fieldValue'";
		}

		if( $fieldChk == "Cellno" )
		{
		    $fieldValue = str_replace( "," , "=" ,$fieldValue);
			$whereCond = " phone_number = '$fieldValue'";
		}
    
		$getUsersDetailQry = "SELECT COUNT(*) AS totalCount
								FROM
				 					user_info
				 				WHERE
				 				$whereCond ";
	//	echo $getUsersDetailQry;
		$getUsersDetailQry = $this->db->query($getUsersDetailQry);
		return $getUsersDetailQry->result_array();
	}
	
    function getAllPatientData($per_page, $count, $type , $searchOnData = "" ) {
        //echo $per_page; die()
        if(!isset($count) || $count == 1 || $count == "delete"){
            $count = 0;
        }
        //echo $per_page. " : " . $count ." : ".$type."<br>";
        if ($this->session->userdata('is_sorted_type') == 0) {
            $this->db->select('id, user_first_name, user_last_name, patient_ref_no,gender,email,date_of_birth,phone_number');
			
			//$array2 = array('user_first_name !=' => '', 'user_last_name !=' => '', 'patient_ref_no !=' => '');
			//$this->db->or_where($array2);
			
			if( trim($searchOnData) != "" )
			{
				$searchOnData1 = $searchOnData;
				
				$searchOnData = str_replace( "chr" , "@" , $searchOnData);
			
				$searchOnData = base64_url_encode($searchOnData);
				$searchOnData = str_replace( "," , "=" , $searchOnData);
			
				$array2 = array('user_first_name ' => $searchOnData, 'user_last_name' => $searchOnData, 'patient_ref_no' => $searchOnData , 'email' => $searchOnData , 'id' => $searchOnData1);
				$this->db->or_where($array2);
			}

			$this->db->where("is_registered",1);
			
			//print_r($this->db->get('user_info')->result_array()); die();
            $list = $this->checkHashValueNew($this->db->get('user_info')->result_array());
			//print_r( $list);
			$list = array_slice($list,$count,$per_page);
			
            /*usort($list, function (array $a, array $b) { return strcmp(strtolower($a['user_first_name']) , strtolower($b['user_first_name'])); });
            $list = array_slice($list,$count,$per_page);
			if(!empty($list)){
				foreach($list as $key=>$info){
					if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
						unset($list[$key]);
					}
				}
				$list = array_values($list);
			}*/
			
			//print_r($list);
			//echo json_encode($list); die();
            return json_decode(json_encode($list), FALSE);
        } else {/*
            $this->db->select('id, user_first_name, user_last_name, patient_ref_no, email');
			$this->db->where("is_registered",1);
            $list = $this->checkHashValueNew($this->db->get('user_info')->result_array());
			
            usort($list, function (array $a, array $b) { return strcmp(strtolower($a['user_last_name']) , strtolower($b['user_last_name'])); });  
            $list = array_slice($list,$count,$per_page);
			if(!empty($list)){
				foreach($list as $key=>$info){
					if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
						unset($list[$key]);
					}
				}
				$list = array_values($list);
			}
			
            // echo json_encode($list);
            return json_decode(json_encode($list), FALSE);
        */}
    }
	
	function getAllNewPatientData($per_page, $count, $type , $searchOnData = "" ) {//
        //echo $per_page; die()
        if(!isset($count) || $count == 1 || $count == "delete"){
            $count = 0;
        }
        //echo $per_page. " : " . $count ." : ".$type."<br>";
        if ($this->session->userdata('is_sorted_type') == 0) {
            $this->db->select('id, user_first_name, user_last_name, patient_ref_no,gender,email,date_of_birth,phone_number');
			
			if( trim($searchOnData) != "" )
			{
				$searchOnData2 = $searchOnData;
			
				$searchOnData = str_replace( "chr" , "@" , $searchOnData);
				$searchOnData1 = $searchOnData = base64_url_encode($searchOnData);
				
				$searchOnData = str_replace( "," , "=" , $searchOnData);
			
				$array2 = array('phone_number ' => $searchOnData1, 'email' => $searchOnData, 'id' => $searchOnData2);
				$this->db->or_where($array2);
			}
			
			$this->db->where('is_registered' , 0);
			
			//print_r($this->db->get('user_info')->result_array()); die();
            
			$list = $this->checkHashValueNew($this->db->get('user_info')->result_array());
			$list = array_slice($list,$count,$per_page);
            
			//usort($list, function (array $a, array $b) { return strcmp(strtolower($a['user_first_name']) , strtolower($b['user_first_name'])); });
            //$list = array_slice($list,$count,$per_page);
			/* if(!empty($list)){
				foreach($list as $key=>$info){
					if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
						unset($list[$key]);
					}
				}
				$list = array_values($list);
			} */
			
			
			//print_r($list);
			//echo json_encode($list); die();
            return json_decode(json_encode($list), FALSE);
        } else {
            $this->db->select('id, user_first_name, user_last_name, patient_ref_no,email');
			$array2 = array('is_registered' => 0);
			$this->db->or_where($array2);
            $list = $this->checkHashValueNew($this->db->get('user_info')->result_array());
			
            usort($list, function (array $a, array $b) { return strcmp(strtolower($a['user_last_name']) , strtolower($b['user_last_name'])); });  
            $list = array_slice($list,$count,$per_page);
			/* if(!empty($list)){
				foreach($list as $key=>$info){
					if($info['user_first_name']==="" && $info['user_last_name']==="" && $info['patient_ref_no']===""){
						unset($list[$key]);
					}
				}
				$list = array_values($list);
			} */
			
            // echo json_encode($list);
            return json_decode(json_encode($list), FALSE);
        }
    }

    function searchPatientData($per_page, $count, $text) {
       // $text = base64_url_encode($text);
        $this->db->select('id, user_first_name, user_last_name, patient_ref_no');//->like('LOWER(user_first_name)', strtolower($text),FALSE)->or_like('LOWER(user_last_name)', strtolower($text),FALSE);
        
       // echo $this->db->last_query();
        return $this->checkHashValue($this->filterValue($this->db->get('user_info'/*, $per_page, $count*/)->result(),$text));            
    }
    function filterValue($list,$text){
	$filteredList = array();
	for($i=0;$i<count($list);$i++){
		if(strpos(strtolower(base64_url_decode($list[$i]->user_first_name)),strtolower($text)) !== false || strpos(strtolower(base64_url_decode($list[$i]->user_last_name)),strtolower($text)) !== false || strpos(strtolower(base64_url_decode($list[$i]->patient_ref_no)),strtolower($text)) !== false){
			$filteredList[count($filteredList)] = $list[$i];
		}
	}
	return $filteredList;
    }	 
    function getSearchTotalPatientCount($text) {
         $text = base64_url_encode($text);
        $this->db->select('count(id) as count')->from('user_info')->like('LOWER(user_first_name)', strtolower($text),FALSE)->or_like('LOWER(user_last_name)', strtolower($text),FALSE);
        $query = $this->db->get()->result();
        return $query[0]->count;
    }
    function getPatientDataByEmailAndId($selected_patient_id,$email) {

        return $this->checkHashValue($this->db->select('*')->get_where('user_info',array('id' => $selected_patient_id,'email' => $email))->result());
    }
    function getPatientDataById($selected_patient_id) {
        return $this->checkHashValue($this->db->select('*')->from('user_info')->where('id', $selected_patient_id)->get()->result());
    }
    function getPatientDataAll() {
        return $this->checkHashValue($this->db->select('*')->from('user_info')->get()->result());
    }
    function getALlSoappRecordByPatient() {
        $list =$this->db->select('SOAPP.id as id,SOAPP.userId as userId ,SOAPP.updateAt as updateAt,question1,question2,question3,question4,question5,question6,question7,question8,question9,question10,question11,question12,question13,question14,question15,question16,question17,question18,question19,question20,question21,question22,question23,question24')->from('SOAPP')->join('user_info', 'user_info.id = SOAPP.userId')->get()->result();
        return $list;
    }
    function getALlCOMMRecordByPatient() {
        $list =$this->db->select('COMM.id as id,COMM.userId as userId ,COMM.updateAt as updateAt,question1,question2,question3,question4,question5,question6,question7,question8,question9,question10,question11,question12,question13,question14,question15,question16,question17')->from('COMM')->join('user_info', 'user_info.id = COMM.userId')->get()->result();
        
        return $list;
    }
    function getALlOPIODRecordByPatient() {
        $list =$this->db->select('user_last_name,OPIOD.id as id,OPIOD.userId as userId ,OPIOD.updateAt as updateAt,question1,question2,question3,question4,question5,question6,question7,question8')->from('OPIOD')->join('user_info', 'user_info.id = OPIOD.userId')->get()->result();
        return $list;
    }
    function getAllUnreadMesages() {
        $list =$this->db->select('*')->from('message_list')->where('read_status', 0)->get()->result();
        
        return $list;
    }
    function getPatientMessageCount($selected_patient_id) {
        return $this->db->select('count(id) as inbox_count')->from('message_list')->where('user_ID', $selected_patient_id)->where('receiverType', ADMIN)->where('read_status', 0)->get()->result();
    }

    function getPatientExerciseAssessmentById($patient_id) {
        return $this->db->select('*')->from('excercise_assessment')->where('user_id', $patient_id)->order_by('created_at', 'desc')->get()->result();
    }

    function getPatientHabitsById($patient_id) {
        return $this->db->select('*')->from('habit')->where('user_id', $patient_id)->order_by('updated_at', 'desc')->get()->result();
    }

    function getPatientDailyReviewDataById($patient_id, $cycle) {
        $end_date = date("Y-m-d");
        $flag = true;
        if ($cycle == "Week")
            $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($end_date)), date("d", strtotime($end_date)) - 7, date("Y", strtotime($end_date))));
        else if ($cycle == "Month")
            $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($end_date)) - 1, date("d", strtotime($end_date)), date("Y", strtotime($end_date))));
        else if ($cycle == "Year")
            $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($end_date)), date("d", strtotime($end_date)), date("Y", strtotime($end_date)) - 1));
        else if ($cycle == "All")
            $flag = false;

        $this->db->select('updatedAt')->where('userid', $patient_id);
        if ($flag) {
            $dateRange = "updatedAt BETWEEN '$start_date' AND '$end_date'";
            $this->db->where($dateRange, NULL, false);
        }
        $this->db->group_by('day(updatedAt)')->order_by('updatedAt', 'asc');
        $result = $this->db->get('dailyreviews')->result();
        return $result;
    }

    function getPatientDailyReviewLastDateById($patient_id) {
        return $this->db->select('updatedAt')->where('userid', $patient_id)->order_by('updatedAt', 'desc')->get('dailyreviews', 1, 0)->result();
    }

    function getPatientDailyReviewDataByDate($patient_id, $selected_date) {
        $selected_date = date("Y-m-d", strtotime($selected_date));
        return $this->db->select('*')->where('userid', $patient_id)->like('updatedAt', $selected_date)->order_by('reviewID', 'asc')->get('dailyreviews')->result();
    }

    function getPatientTaskReviewByReviewId($patient_id, $reviewID) {
        return $this->db->select('*')->where('userid', $patient_id)->where('reviewID', $reviewID)->order_by('taskId', 'asc')->get('taskreviews')->result();
    }

    function saveMessage($patient_id, $message, $subject) {
        $email = $this->checkHashValue($this->db->select('email')->from('user_info')->where('id', $patient_id)->get()->result());
        $email = $email[0]->email;
        $data = array(
            'user_ID' => $patient_id,
            'subject' => $subject,
            'messageText' => $message,
            'receiverType' => USER,
            'read_status' => 0,
            'readStatusServer' => 0,
            'created_at' => time()
        );
        $this->db->insert('message_list', $data);
    }

    function getPatientInboxMessageCount($patient_id) {
        $rows = $this->db->select('count(*) as count_')->from('message_list')->where('user_ID', $patient_id)->where('receiverType', ADMIN)->get()->result();
        return $rows[0]->count_;
    }
    function getPatientCombinedInboxMessageCount() {
       //$rows = $this->db->select('count(*) as count_')->from('message_list')->where('read_status', 0)->where('receiverType', ADMIN)->get()->result();

		$qStr = "SELECT count(message_list.id) as count_
					FROM
				 message_list
				 JOIN 
					user_info
				 ON
					user_info.id = message_list.user_ID
				 WHERE read_status = '0' AND receiverType = ".ADMIN;
		//die();	 
		$query = $this->db->query($qStr);
		$result = $query->row_array();
		return (empty($result['count_'])?0:$result['count_']);
        //return $rows[0]->count_;
    }
	function getPatientCombinedOutboxMessageCount() {
		$qStr = "SELECT count(message_list.id) as count_
					FROM
				 message_list
				 JOIN 
					user_info
				 ON
					user_info.id = message_list.user_ID
				 WHERE
				 receiverType = ".USER;
		//die();	 
		$query = $this->db->query($qStr);
		$result = $query->row_array();
		return (empty($result['count_'])?0:$result['count_']);
    }
    function getPatientReceivedMessage($per_page, $count, $patient_id) {
        $this->db->select('*')->where('user_ID', $patient_id)->where('receiverType', ADMIN)->order_by('message_list.id', 'desc');
        return $this->db->get('message_list', $per_page, $count)->result();
    }
    function getPatientReceivedMessageCombinedInbox( $searchOnData = "" ) {
	
		$where1 = "receiverType = " . ADMIN;
		
		if( trim($searchOnData) != "" )
		{
			$searchOnData1 = $searchOnData;
			
			$searchOnData = str_replace( "chr" , "@" , $searchOnData);
		
			$searchOnData2 = $searchOnData = base64_url_encode($searchOnData);
			$searchOnData = str_replace( "," , "=" , $searchOnData);
		
			$where1 .= " AND ( user_first_name= '$searchOnData' OR ";
			$where1 .= " user_last_name= '$searchOnData' OR ";
			$where1 .= " phone_number= '$searchOnData2' OR ";
			$where1 .= " patient_ref_no= '$searchOnData' OR ";
			$where1 .= " email= '$searchOnData' OR ";
			$where1 .= " user_info.id = '$searchOnData1' ) ";
			
			/* $array2 = array('user_first_name ' => $searchOnData, 'user_last_name' => $searchOnData
			, 'phone_number' => $searchOnData2 , 'patient_ref_no' => $searchOnData , 'email' => $searchOnData , 'user_info.id1' => $searchOnData1);
			$this->db->or_where($array2); */
		}
		
		$this->db->where($where1);
	
        $this->db->select('message_list.*,user_info.email , user_info.phone_number , user_info.id as userID ,user_info.user_first_name,user_info.user_last_name')->order_by('message_list.id', 'desc');
        $this->db->join('user_info', 'user_info.id = message_list.user_ID');
        return $this->checkHashValue($this->db->get('message_list')->result());
    }
	
	function getPatientReceivedMessageCombinedOutbox( $searchOnData = "" ) {
       
		$where1 = "receiverType = " . USER;
		
		if( trim($searchOnData) != "" )
		{
			$searchOnData1 = $searchOnData;
			
			$searchOnData = str_replace( "chr" , "@" , $searchOnData);
		
			$searchOnData2 = $searchOnData = base64_url_encode($searchOnData);
			$searchOnData = str_replace( "," , "=" , $searchOnData);
		
			$where1 .= " AND ( user_first_name= '$searchOnData' OR ";
			$where1 .= " user_last_name= '$searchOnData' OR ";
			$where1 .= " phone_number= '$searchOnData2' OR ";
			$where1 .= " patient_ref_no= '$searchOnData' OR ";
			$where1 .= " email= '$searchOnData' OR ";
			$where1 .= " user_info.id = '$searchOnData1' ) ";
			
			/* $array2 = array('user_first_name ' => $searchOnData, 'user_last_name' => $searchOnData
			, 'phone_number' => $searchOnData2 , 'patient_ref_no' => $searchOnData , 'email' => $searchOnData , 'user_info.id1' => $searchOnData1);
			$this->db->or_where($array2); */
		}
		
		$this->db->where($where1);
	   
	    $this->db->select('message_list.*,user_info.email , user_info.phone_number , user_info.id as userID ,user_info.user_first_name,user_info.user_last_name')->order_by('message_list.id', 'desc');
        $this->db->join('user_info', 'user_info.id = message_list.user_ID');
        return $this->checkHashValue($this->db->get('message_list')->result());
    }
	
    function getPatientOutboxMessageCount($patient_id) {
        $rows = $this->db->select('count(*) as count_')->from('message_list')->where('user_ID', $patient_id)->where('receiverType', 1)->get()->result();
        return $rows[0]->count_;
    }

    function getPatientSentMessage($per_page, $count, $patient_id) {
        $this->db->select('*')->where('user_ID', $patient_id)->where('receiverType', USER)->order_by('id', 'desc');
        return $this->db->get('message_list', $per_page, $count)->result();
    }

    function getMessageById($message_id) {
        return $this->db->select('*')->from('message_list')->where('id', $message_id)->get()->result();
    }

    function readMessageById($message_id) {
        $data = array('read_status' => 1,'readStatusServer' => 1);
        $this->db->where('id', $message_id);
        $this->db->update('message_list', $data);
    }

    function getCurrentDisease($patient_id) {
        return $this->db->select('current_diseas as disease')->where('id', $patient_id)->from('user_info')->get()->result();
    }

    function getMedicationListByPatientId($type) {
        return $this->db->select('*')->from('medicationlist')->where('MedicationType', $type)->order_by('MedicineName', 'asc')->get()->result();
    }

    function deleteMedicineById($medicine_id) {
        $this->db->delete('medicationlist', array('medication_List_ID' => $medicine_id));
    }

    function addMedicine($patient_id, $medicine_name, $type) {
        $data = array(
            'user_ID' => $patient_id,
            'MedicineName' => $medicine_name,
            'UpdatedBy' => $this->session->userdata('user_first_name'),
            'UpdateAt' => date('Y-m-d G:i:u'),
            'MedicationType' => $type
        );
        $this->db->insert('medicationlist', $data);
    }

    function getXaxisTagsForGraph($duration, $patient_id) {
        $x_axis_ = array();
        if ($duration == "week") {
            $end_date = date("Y-m-d");
            $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($end_date)), date("d", strtotime($end_date)) - 6, date("Y", strtotime($end_date))));
            for ($i = 0; $i < 7; $i++) {
                $x_axis_[$i] = $start_date;
                $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($start_date)), date("d", strtotime($start_date)) + 1, date("Y", strtotime($start_date))));
            }
            return $x_axis_;
        } else if ($duration == "month") {
            $end_date = date("Y-m-d");
            $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($end_date)), date("d", strtotime($end_date)) - 21, date("Y", strtotime($end_date))));
            for ($i = 0; $i < 4; $i++) {
                $x_axis_[$i] = $start_date;
                $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($start_date)), date("d", strtotime($start_date)) + 7, date("Y", strtotime($start_date))));
            }
            return $x_axis_;
        } else if ($duration == "year") {
            $end_date = date("Y-m-d");
            $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($end_date)) - 11, date("d", strtotime($end_date)), date("Y", strtotime($end_date))));
            for ($i = 0; $i < 12; $i++) {
                $x_axis_[$i] = $start_date;
                //echo $start_date;
                $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($start_date)) + 1, date("d", strtotime($start_date)), date("Y", strtotime($start_date))));
            }
            /* 	var_dump($x_axis_);
              die(); */
            return $x_axis_;
        } else if ($duration == "all") {
            $result = $this->db->select('MIN(entered_at) as start_date, MAX(entered_at) as end_date')->from('weight_assessment')->where('user_id', $patient_id)->get()->result();
            $start_date = date("Y-m-d", $result[0]->start_date);
            $end_date = date("Y-m-d", $result[0]->end_date);
            $total_days = strtotime($end_date) - strtotime($start_date);
            $total_days = floor($total_days / (60 * 60 * 24));
            $iter_days = 0;
            $iter_month = 0;
            if ($total_days <= 7)
                $iter_days = 1;
            else if ($total_days <= 31)
                $iter_days = 7;
            else if ($total_days <= 365)
                $iter_month = 1;
            else
                $iter_month = 6;
            $flag = true;
            $equal_dates_done = false;
            $i = 0;
            while ($flag) {
                $x_axis_[$i] = $start_date;
                $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($start_date)) + $iter_month, date("d", strtotime($start_date)) + $iter_days, date("Y", strtotime($start_date))));
                $i += 1;
                if (strtotime($start_date) == strtotime($end_date))
                    $equal_dates_done = true;
                if (strtotime($start_date) > strtotime($end_date))
                    $flag = false;
            }
            if (!$equal_dates_done) {
                $x_axis_[$i] = $end_date;
            }
            return $x_axis_;
        }
    }

    function getXaxisTagsForMonthGraph($duration, $patient_id) {
        $x_axis_ = array();

        $end_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($duration)), date("d", strtotime($duration)), date("Y", strtotime($duration))));
        $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($end_date)), date("d", strtotime($end_date)) - 21, date("Y", strtotime($end_date))));
        for ($i = 0; $i < 4; $i++) {
            $x_axis_[$i] = $start_date;
            $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($start_date)), date("d", strtotime($start_date)) + 7, date("Y", strtotime($start_date))));
        }

        return $x_axis_;
    }

    function getYaxisValuesForCompletePeriod($graph_type, $duration, $patient_id, $x_axis_tags, $sel_column) {
        $y_axis_values = array();
		$x_axis_tags[0] = strtotime($x_axis_tags[0]);
		$today = time();
		$dateRange = "entered_at BETWEEN '$x_axis_tags[0]' AND '$today'";
        $y_axis_values[0] = $this->db->select("AVG(weight) as average_value")->from('weight_assessment')->where('user_id', $patient_id)->where($dateRange, NULL, false)->get()->result();
        $y_axis_values[0] = $y_axis_values[0][0]->average_value;
        $total_count = count($x_axis_tags);
        for ($i = 1; $i < $total_count; $i++) {
            $start_date = $x_axis_tags[$i - 1];
            $start_date = date("Y-m-d", mktime(0, 0, 0, date("m", strtotime($start_date)), date("d", strtotime($start_date)) + 1, date("Y", strtotime($start_date))));
            $end_date = $x_axis_tags[$i];
            $dateRange = "entered_at BETWEEN '$start_date' AND '$end_date'";
            $result = $this->db->select('AVG(weight) as average_value')->from('weight_assessment')->where('user_id', $patient_id)->where($dateRange, NULL, false)->get()->result();
            if ($result[0]->average_value == NULL)
                $y_axis_values[] = 0;
            else
                $y_axis_values[] = $result[0]->average_value;
        }
        $prev_value = $y_axis_values[0];
        //var_dump($y_axis_values);

        for ($i = 1; $i < $total_count; $i++) {
            if ($y_axis_values[$i] == 0) {
                $span_count = 1;
                $next_value = "0";
                for ($j = $i + 1; $j < $total_count; $j++) {
                    if ($y_axis_values[$j] == 0) {
                        $span_count += 1;
                    } else {
                        $span_count += 1;
                        $next_value = $y_axis_values[$j];
                        break;
                    }
                }
                $inc = ($next_value - $prev_value) / $span_count;
                for ($k = $i; $k < $j; $k++) {
                    $y_axis_values[$k] = $prev_value + $inc;
                    $prev_value = $y_axis_values[$k];
                }
                $i = $i + $span_count - 1;
                //die();
            }
            $prev_value = $y_axis_values[$i];
        }
        return $y_axis_values;
    }

    function getYaxisValuesForGraph($graph_type, $duration, $patient_id, $x_axis_tags) {
        $total_count = count($x_axis_tags);
		if ($graph_type == "pain_graph") {
            $sel_column = "average_pain";
        } else if ($graph_type == "sleep_graph") {
            $sel_column = "pain_intereferd_with_sleep";
        } else if ($graph_type == "mood_graph") {
            $sel_column = "depress_and_anxious";
        } else if ($graph_type == "activity_graph") {
            $sel_column = "interfered_daily_activity";
        }
        if ($duration == "all") {
            $y_axis_values = $this->getYaxisValuesForCompletePeriod($graph_type, $duration, $patient_id, $x_axis_tags, $sel_column);
            return $y_axis_values;
        }
        //$sel_column = "average_pain";
        $this->db->select('AVG(' . $sel_column . ') as average_pain')->from('dailyreviews');
        $dateRange = "updatedAt < '$x_axis_tags[0]'";
        $this->db->where($dateRange, NULL, false);
        $this->db->where('userid', $patient_id);
        $result = $this->db->get()->result();
        //echo($this->db->last_query());
        if ($result[0]->average_pain != NULL)
            $start_value = $result[0]->average_pain;
        else
            $start_value = NULL;
        $y_axis_values = array();
        $y_axis_values[0] = $start_value;
        //die(strval(intval($start_value)));
        for ($i = 1; $i < $total_count; $i++) {
            $start_date = $x_axis_tags[$i - 1];
            $end_date = $x_axis_tags[$i];
            $dateRange = "updatedAt BETWEEN '$start_date' AND '$end_date'";
            $result = $this->db->select('AVG(' . $sel_column . ') as average_pain')->from('dailyreviews')->where('userid', $patient_id)->where($dateRange, NULL, false)->get()->result();
            //echo $this->db->last_query();
            if ($result[0]->average_pain == NULL)
                $y_axis_values[] = 0;
            else
                $y_axis_values[] = $result[0]->average_pain;
        }
        $prev_value = $y_axis_values[0];
        //var_dump($y_axis_values);

        $start_flag = true;
        $end_zero_range = true;
        for ($i = 1; $i < $total_count; $i++) {
            if ($y_axis_values[$i] == 0 && !$start_flag) {
                $span_count = 1;
                $next_value = "0";
                for ($j = $i + 1; $j < $total_count; $j++) {
                    if ($y_axis_values[$j] == 0) {
                        $span_count += 1;
                        $end_zero_range = true;
                    } else {
                        $span_count += 1;
                        $next_value = $y_axis_values[$j];
                        $end_zero_range = false;
                        break;
                    }
                }
                if (!$end_zero_range) {
                    $inc = ($next_value - $prev_value) / $span_count;
                    for ($k = $i; $k < $j; $k++) {
                        $y_axis_values[$k] = $prev_value + $inc;
                        $prev_value = $y_axis_values[$k];
                    }
                    $i = $i + $span_count - 1;
                } else {
                    for ($m = $i; $m < $j; $m++) {
                        $y_axis_values[$m] = NULL;
                    }
                }
                //die();
            } else if ($y_axis_values[$i] != 0)
                $start_flag = false;
            else if ($y_axis_values[$i] == 0)
                $y_axis_values[$i] = NULL;
            $prev_value = $y_axis_values[$i];
        }
        /* var_dump($y_axis_values);
          die(); */
        return $y_axis_values;
    }

    function getPatientDataforReport($patient_id) {
        return $this->checkHashValue($this->db->select('*')->from('user_info')->where('id', $patient_id)->get()->result());
    }

    function getPatientCurrentMedication($patient_id, $type) {
        return $this->db->select('MedicineName')->from('medicationlist')->where('user_ID', $patient_id)->where('MedicationType', $type)->get()->result();
    }

    function getPatientPainPositionData($patient_id) {
        return $this->db->select('user_ID, pain_possition as pain_position,isNewFormat,updatedAt')->from('painpossition')->where('user_ID', $patient_id)->order_by('updatedAt','ASC')->get()->result();
    }

    function getAllPatient($searchOnData = "") {
	
		if( trim($searchOnData) != "" )
		{
			$searchOnData1 = $searchOnData;
			
			$searchOnData = str_replace( "chr" , "@" , $searchOnData);
		
			$searchOnData = base64_url_encode($searchOnData);
			$searchOnData = str_replace( "," , "=" , $searchOnData);
		
			$array2 = array('user_first_name ' => $searchOnData, 'user_last_name' => $searchOnData, 'patient_ref_no' => $searchOnData , 'email' => $searchOnData , 'id' => $searchOnData1);
			$this->db->or_where($array2);
		}
				
        return $this->checkHashValue($this->db->select('id as userID, user_first_name, user_last_name,patient_ref_no, gender,email,date_of_birth,current_weight,current_height,phone_number')->from('user_info')->order_by("user_first_name", "asc")->get()->result());
    }
    function getInitialPatientDataCSV($patient_list) {
        $data= '';
        $list =$this->checkHashValue($this->db->select('*')->from('userevaluation')->where_in('User_Id',$patient_list)->get()->result());
        $array = get_object_vars($list[0]);
        $properties = array_keys($array);
        $data .= implode($properties, ',');
        $data .= "\n";
        for ($i=0; $i < count($list);$i++) {
            $data .= implode(array_values(get_object_vars($list[$i])),',');
            $data .= "\n";
        }
        return $data;
    }
    function getDailyPatientDataCSV($patient_list) {
        $data= '';
        $list =$this->checkHashValue($this->db->select('*')->from('dailyreviews')->where_in('userid',$patient_list)->get()->result());
        $array = get_object_vars($list[0]);
        $properties = array_keys($array);
        $data .= implode($properties, ',');
        $data .= "\n";
        for ($i=0; $i < count($list);$i++) {
            $data .= implode(array_values(get_object_vars($list[$i])),',');
            $data .= "\n";
        }
        return $data;
    }
    
	function deletePatients($patients) {
		//print_r($patients);
		//exit;
		
		$patients = implode( "','" , $patients );
		
		$deleteQry = "DELETE FROM user_info WHERE id IN ( '$patients' ) ";
		$deleteQry = $this->db->query($deleteQry);

		$deleteQry = "DELETE FROM diet_assessment WHERE user_id IN ( '$patients' ) ";
		$deleteQry = $this->db->query($deleteQry);

		$deleteQry = "DELETE FROM excercise_assessment WHERE user_id IN ( '$patients' ) ";
		$deleteQry = $this->db->query($deleteQry);

		$deleteQry = "DELETE FROM goal WHERE user_id IN ( '$patients' ) ";
		$deleteQry = $this->db->query($deleteQry);

		$deleteQry = "DELETE FROM habit WHERE user_id IN ( '$patients' ) ";
		$deleteQry = $this->db->query($deleteQry);

		$deleteQry = "DELETE FROM message_list WHERE user_ID IN ( '$patients' ) ";
		$deleteQry = $this->db->query($deleteQry);

		$deleteQry = "DELETE FROM user_settings WHERE user_id IN ( '$patients' ) ";
		$deleteQry = $this->db->query($deleteQry);

		$deleteQry = "DELETE FROM weight_assessment WHERE user_id IN ( '$patients' ) ";
		$deleteQry = $this->db->query($deleteQry);
		//return $query = $this->db->query($qStr);
	}
	
	function getPatients($patient_list) {
        $data= '';
		
        //$list = $this->checkHashValue($this->db->select('id, user_first_name,user_last_name,gender,date_of_birth,email,current_weight,current_height,phone_number')->from('user_info')->where_in('id',$patient_list)->get()->result());

		$patientIds = $patient_list;
		$patientIds = implode("," , $patientIds);
		
		$dataQry = "
				SELECT 
				  user_info.id as UserID,
				   user_first_name,
				   user_last_name,
				   date_of_birth,
				   gender,
				   concat( ( FLOOR((current_height*3.2808399))) , ' Feet ' , round( 12 * ((current_height*3.2808399) - FLOOR(current_height*3.2808399))  ) , ' inches' ) as Height ,
				   current_weight as InitialWeight, 
				   round(current_weight / POW(current_height, 2), 2) AS BMI,
				
				/*( SELECT ( group_concat( concat(if(goal_type = 1, 'Weight Loss Goal(KG)', if(goal_type = 2, 'Weekly Exercise Goal(Min)', if(goal_type = 3, 'Daily Diet Goal(Cal)', ''))), ':', goal_data) separator'|' ) )  FROM goal WHERE goal.user_id = user_info.id ) AS Goals , */
				
				( SELECT goal_data  FROM goal WHERE goal.user_id = user_info.id AND goal_type = 1 ) AS WeightLoss ,
				( SELECT goal_data  FROM goal WHERE goal.user_id = user_info.id AND goal_type = 2 ) AS WeeklyExercise , 
				( SELECT goal_data  FROM goal WHERE goal.user_id = user_info.id AND goal_type = 3 ) AS DailyDiet , 
				
				( SELECT  weight FROM weight_assessment WHERE weight_assessment.user_id = user_info.id AND 
				weight_assessment.`entered_at` <= UNIX_TIMESTAMP(Now()) LIMIT 1
				 ) AS Weight,

				( SELECT  round( weight/POW(current_height, 2) , 2 ) FROM weight_assessment WHERE weight_assessment.user_id = user_info.id AND 
				weight_assessment.`entered_at` <= UNIX_TIMESTAMP(Now()) LIMIT 1
				 ) AS BMI1
				
				/* , (
				SELECT 
				concat(diet_type, ':', diet_time, ':', calories) FROM diet_assessment
				WHERE diet_assessment.user_id = user_info.id AND 
				diet_assessment.`created_at` <= UNIX_TIMESTAMP(Now()) LIMIT 1
				) AS Diet
				 ,  
				(
				SELECT 
				concat(activity_type, ':', duration, ':') FROM excercise_assessment
				WHERE excercise_assessment.user_id = user_info.id AND 
				excercise_assessment.`created_at` <= UNIX_TIMESTAMP(Now()) LIMIT 1
				) AS Excercise */
				
				FROM
				  user_info
				  LEFT OUTER JOIN goal ON (user_info.id = goal.user_id)
				  LEFT OUTER JOIN excercise_assessment ON (user_info.id = excercise_assessment.user_id)
				  LEFT OUTER JOIN diet_assessment ON (user_info.id = diet_assessment.user_id)
				  LEFT OUTER JOIN weight_assessment ON (user_info.id = weight_assessment.user_id)
				
				WHERE user_info.id IN ($patientIds)
				  
				GROUP BY
				  user_info.id		
		";
		
		$query = $this->db->query($dataQry);
		$result = $query->result();
		//print_r($result);
		//exit;
		
		$list = $this->checkHashValue($result);  

		//print_r($list);
		//exit;
		
		$array = get_object_vars($list[0]);
		
        $properties = array_keys($array);
		
		$properties1 = array();
		$userDataVals = array();
		$userDataVals["user_first_name"] = "First Name";
		$userDataVals["user_last_name"] = "Last Name";
		$userDataVals["gender"] = "Gender";
		$userDataVals["date_of_birth"] = "Date Of Birth";
		$userDataVals["email"] = "User Email";
		$userDataVals["current_weight"] = "Initial Weight (kg)";
		$userDataVals["phone_number"] = "User Phone No.";
		$userDataVals["BMI"] = "Initial BMI";
		$userDataVals["Height"] = "Height (ft & in)";
		//$userDataVals["Goals"] = "Goals";
		$userDataVals["WeightLoss"] = "Weight Loss Goal(KG)";
		$userDataVals["WeeklyExercise"] = "Weekly Exercise Goal(Min)";
		$userDataVals["DailyDiet"] = "Daily Diet Goal(Cal)";
		
		$userDataVals["Weight"] = "Current Weight (kg)";
		$userDataVals["Diet"] = "Diet";
		$userDataVals["Excercise"] = "Exercise Goal (min)";
		$userDataVals["BMI1"] = "Current BMI";
		
		foreach( $properties as $key => $val )
		{
			$properties1[$key] = (!empty($userDataVals[$val]) ? $userDataVals[$val] : $val );
		}
		
		//$properties = $properties1;
		
		//$properties = array_keys($properties1);
		
		//print_r($properties1);
		//exit;
		
        $data .= implode($properties1, ',');
		
		$data .= "\n";
        for ($i=0; $i < count($list);$i++) {
		
			if( $list[$i]->date_of_birth != "" )
			{
				$list[$i]->date_of_birth = ( !empty($list[$i]->date_of_birth) ? date( "d M Y" , $list[$i]->date_of_birth) : "" );	
			}
		
            $data .= implode(array_values(get_object_vars($list[$i])),',');
            $data .= "\n";
        }
		
        return $data;
    }
	function isUserPhoneExist($user_phone) {
		$qStr = "SELECT
					*
				 FROM
					user_info
				 WHERE 
					`phone_number` = '".$user_phone."'";
		
		$query = $this->db->query($qStr);  
		$result = $query->row_array();
		if(!empty($result)){
			return $result['id'];
		} else{
			return 0;
		}
	}
	//05: isUserEmailExist
	function isUserEmailExist($user_email){
		$qStr = "SELECT 
					*
				 FROM
					user_info
				 WHERE 
					email = '".$user_email."'";
		
		$query = $this->db->query($qStr);
		$result = $query->row_array();
		if(!empty($result)){
			return $result['id'];
		} else{
			return 0;
		}
	}
	function import($first_name,$last_name,$phone,$email,$gender,$weight,$height,$dob){
		
		$user_id = "";
		//Check if Phone/Email Exist than Update the Record
		$phoneExist = $this->isUserPhoneExist($phone);
		$emailExist = $this->isUserEmailExist($email);
		if ($phoneExist == 0 && $emailExist == 0){
			$qStr = "INSERT INTO 
					`user_info`
						SET
					`user_first_name` = '".addslashes($first_name)."' , `user_last_name` = '".addslashes($last_name)."' , `phone_number` = '".addslashes($phone)."',
					`email` = '".addslashes($email)."' ,`gender` = '".addslashes($gender)."' , current_weight='".addslashes($weight)."' , current_height='".addslashes($height)."', date_of_birth='".addslashes($dob)."',
					`isHashed` = 1";
						
			$query = $this->db->query($qStr);
			return true;		
		}  elseif ($phoneExist!= 0 || $emailExist != 0){
			if($phoneExist !=0){
				$user_id = $phoneExist;
			}else {
				$user_id = $emailExist;
			}
			$qStr = "UPDATE 
					`user_info`
						SET
					`user_first_name` = '".addslashes($first_name)."' , `user_last_name` = '".addslashes($last_name)."' , `phone_number` = '".addslashes($phone)."',
					`email` = '".addslashes($email)."' ,`gender` = '".addslashes($gender)."' , current_weight='".addslashes($weight)."' , current_height='".addslashes($height)."', date_of_birth='".addslashes($dob)."',
					`isHashed` = 1
					 WHERE 
						id = '".$user_id."'";
						
			$query = $this->db->query($qStr);
			return false;
		}
	}
    function getAllAppointment() {
        return $this->db->select('*')->from('appointment')->get()->result();
    }
    function addMedicationLink($_link, $_title) {
        $data = array(
            'title' => $_title,
            'link' => $_link
        );
        $this->db->insert('medicationLink', $data);
    }
    function saveAppointment($id, $from, $dr_name, $notes , $appointmentReqID = "" ) {
	
		if( $appointmentReqID != "" )
		{
			$qStr1 = "DELETE FROM appoitment_request WHERE id='".$appointmentReqID."'";
			$query1 = $this->db->query($qStr1);
		}
		
		$appointmentDateTime = date( "M d , Y h:i:s a" , strtotime($from) );
		
        $data = array(
            'patient_id' => $id,
            'time' => strtotime($from),
            'doctor_name' => $dr_name,
            'notes' => $notes,
            'created_at' => time() ,
			'appointment_date_time' => $appointmentDateTime
//            'end_time' => $to
        );
        $this->db->insert('appointment', $data);
    }

    function removeAppointment($id) {
        $this->db->delete('appointment', array('appointment_id' => $id));
    }

    function searchAppointment($id) {
        return $this->checkHashValue($this->db->select('appointment.*,user_info.user_first_name,user_info.user_last_name')->from('appointment')->join('user_info','appointment.patient_id = user_info.id')->where('appointment.patient_id', $id)->get()->result());
    }
    function AllAppointmentToday() {
        $var = $this->checkHashValue($this->db->select('appointment.*,user_info.user_first_name,user_info.user_last_name')->from('appointment')->join('user_info','appointment.patient_id = user_info.id')->where('appointment.time >=',  strtotime(date('d.m.Y',strtotime("-1 days"))) )->get()->result());
        return $var;
    }
    function getAllGoal($pID) {
        return $this->db->select('*')->from('goal')->where('user_id', $pID)->order_by("updated_at", "desc")->get()->result();
    }
    function getPatientWeight($patient_id) {
        return $this->db->select('weight_assessment.*,user_info.current_height')->from('weight_assessment')->join('user_info','weight_assessment.user_id = user_info.id')->where('user_id', $patient_id)->order_by("entered_at", "desc")->get()->result();
    }
    function getPatientDietAssessment($patient_id) {
        return $this->db->select('*')->from('diet_assessment')->where('user_id', $patient_id)->order_by("created_at", "desc")->get()->result();
    }
	
	function getDietReports($patient_id,$date) {
		$date = strtotime($date);
		$end_date = strtotime('+1 day', $date);
        return $this->db->select('diet_time,calories')->from('diet_assessment')->where('created_at >=', $date)->where('created_at <', $end_date)->where('user_id', $patient_id)->order_by("created_at", "desc")->get()->result();
    }
	
	function getExerciseReports($patient_id,$date) {
		$date = strtotime($date);
		$end_date = strtotime('+1 day', $date);
        return $this->db->select('activity_type,duration,created_at')->from('excercise_assessment')->where('created_at >=', $date)->where('created_at <', $end_date)->where('user_id', $patient_id)->order_by("created_at", "desc")->get()->result();
    }
	
	function getReports($patient_id,$time){
		$where = "";
		//$where .= ($time == 1)? 'entered_at >= '.time().'-'.WEEK.' AND':'';
		//$where .= ($time == 2)? 'entered_at >= '.time().'-'.MONTH.' AND':'';
		$where .= ($time == 1)? 'entered_at >= '.strtotime( '-1 week', time() ).' AND':'';
		$where .= ($time == 2)? 'entered_at >= '.strtotime( '-1 month', time() ).' AND':'';
		$qStr = "SELECT *, count(*) as total_assessments
					FROM
				 weight_assessment
				 WHERE
				 ".$where." user_id = ".$patient_id."
				 GROUP BY entered_at
				 ORDER BY entered_at ASC";
		//die();	 
		$query = $this->db->query($qStr);
		return $result = $query->result_array();
		//print_r($result); die();
	}
	function getReportsArray($patient_id,$time){
		$where = "";
		$where .= ($time == 1)? 'entered_at >= '.time().'-'.WEEK.' AND':'';
		$where .= ($time == 2)? 'entered_at >= '.time().'-'.MONTH.' AND':'';
		$qStr = "SELECT *
					FROM
				 weight_assessment
				 WHERE
				 ".$where." user_id = ".$patient_id;
		$query = $this->db->query($qStr);
		return $result = $query->result_array();
	}

    function addReportUpload($topic_id, $file_name) {

        date_default_timezone_set('America/New_York');
      $arr = explode("__", $file_name);
        $data = array(
            'patient_id' => $topic_id,
            'report_path' => $file_name,
            'report_upload_time' => date('Y-m-d H:i:s'),
            'reportName' => $arr[1]
        );

        $this->db->insert('paitent_report', $data);
    }

    function getAllMedicationLink() {
        return $this->db->select('*')->from('medicationLink')->get()->result();
    }
    function getAllReports() {
        return $this->db->select('*')->from('paitent_report')->get()->result();
    }
    function removeReport($id) {
        $this->db->delete('paitent_report', array('report_id' => $id));
    }
    function removeLink($id) {
        $this->db->delete('medicationLink', array('medicationLinkId' => $id));
    }
	
	function getUsersDetail($userName)
	{
		$userName = base64_url_encode($userName);
		
		$getUsersDetailQry = "SELECT *
								FROM
				 					admin_user
				 				WHERE
				 				user_name = '$userName'";
		$getUsersDetailQry = $this->db->query($getUsersDetailQry);
		return $result = $getUsersDetailQry->result_array();
	}
	
	function updateUserPassword($userName , $password) {
        
		$userName = base64_url_encode($userName);		
		$password = base64_url_encode(md5($password));
		
		$data = array('password' => $password);
		
        $this->db->where('user_name', $userName);
        $this->db->update('admin_user', $data);
		
		return 1;
    }
	
	function getAppointmentsList( $whereCond = "" ) {
		
		if( $whereCond != "" )
		{
			$this->db->where($whereCond);
	   	}
		
		$dataQry = " 
					SELECT
					  user_info.* , appoitment_request.id AS reqID
					FROM
					  appoitment_request
					  INNER JOIN user_info ON (appoitment_request.user_id = user_info.id) ";
		
		$query = $this->db->query($dataQry);
		$result = $query->result();
		return $list = $this->checkHashValue($result);
    }
	
    function getAppointmentsCount() {

		$qStr = "SELECT COUNT(appoitment_request.id) AS count_
					FROM
					  appoitment_request
				  INNER JOIN user_info ON (appoitment_request.user_id = user_info.id)
  		";
			 
		$query = $this->db->query($qStr);
		$result = $query->row_array();
		return (empty($result['count_'])?0:$result['count_']);
        //return $rows[0]->count_;
    }

	function getUsersBasicInfo( $whereCond = "" ) {
		
		$dataQry = " SELECT 
					  user_info.*
					FROM
					  user_info
					  WHERE $whereCond
					";
		$datesVals1 = $this->db->query($dataQry);
		$datesVals = $datesVals1->result_array();
		
		$userInfo = array();
		
		foreach( $datesVals as $userKey => $userVal )
		{
			$firstName = ucfirst(preg_replace('/\s+/', '', base64_url_decode($userVal["user_first_name"])));
			$lastName = ucfirst(preg_replace('/\s+/', '', base64_url_decode($userVal["user_last_name"])));
			$date_of_birth = (preg_replace('/\s+/', '', base64_url_decode($userVal["date_of_birth"])));
			$gender = ucfirst(preg_replace('/\s+/', '', base64_url_decode($userVal["gender"])));
			$phone_number = (preg_replace('/\s+/', '', base64_url_decode($userVal["phone_number"])));
			$email = (preg_replace('/\s+/', '', base64_url_decode($userVal["email"])));
			$current_weight = $userVal["current_weight"];
			$current_height = $userVal["current_height"];
			
			$userInfo[$userVal["id"]] = array( 
			"user_fullname" => $firstName . " " . $lastName 
			, "date_of_birth" => $date_of_birth
			, "gender" => $gender
			, "phone_number" => $phone_number
			, "email" => $email
 			, "current_weight" => $current_weight
			, "current_height" => $current_height );
		}
		
		return $userInfo;
	}

	function getWeightGraphData( $whereCond = "" , $datesVals = array() ) {
		
		$dataQry = " SELECT 
					  user_info.user_first_name,
					  user_info.user_last_name , weight_assessment.*
					FROM
					  weight_assessment
					  INNER JOIN user_info ON (weight_assessment.user_id = user_info.id)
					  
					  WHERE $whereCond
					  GROUP BY (weight_assessment.entered_at)
					";
		
		$datesVals1 = $this->db->query($dataQry);
		$datesVals = $datesVals1->result_array();

		$dataQry = " SELECT 
					  user_info.user_first_name,
					  user_info.user_last_name , weight_assessment.*
					FROM
					  weight_assessment
					  INNER JOIN user_info ON (weight_assessment.user_id = user_info.id)
					  
					  WHERE $whereCond
					";
		
		$dataQry1 = $this->db->query($dataQry);
		$graphData1 = $dataQry1->result_array();
		
		$userVals = array();
		$userVals1 = array();
		//$datesVals = array();
		
		//$datesVals = $this->getDatesListOnDemVal("2018-07-01" , "2018-07-05" , "86400");
		
		$graphDates = '';

		foreach( $datesVals as $dateKey => $dateVal )
		{
			$dateValue = (!empty($dateVal["entered_at"]) ? date( "Y-m-d" , $dateVal["entered_at"] ) : "" );
			
			$graphDates .=  '"' . $dateValue . '",';
		}				
		
		foreach( $graphData1 as $graphDataKey => $graphDataVals )
		{
			$weightDate = date( "Y-m-d" , $graphDataVals["entered_at"] );
			
			//$datesVals[$weightDate] = $weightDate;
			
			$firstName = ucfirst(preg_replace('/\s+/', '', base64_url_decode($graphDataVals["user_first_name"])));
			$lastName = ucfirst(preg_replace('/\s+/', '', base64_url_decode($graphDataVals["user_last_name"])));
			
			$user = $firstName . "-" . $lastName;
			
			$userVals1[$graphDataVals["user_id"]] = $user;
			
			$userVals[$graphDataVals["user_id"]][$weightDate] = array( "user" => $user  , "weight" => $graphDataVals["weight"]);
		}
		
			$graphData = '[';
			
			foreach( $userVals as $userWeightKey => $userWeightVals )
			{
				$user = $userVals1[$userWeightKey];
				
				$graphData .= '{ "name" : "' . $user . '" , ';
				 
				$graphDataVals1 = "";
				 
				foreach( $datesVals as $dateKey => $dateVal )
				{
					 $dateValue = (!empty($dateVal["entered_at"]) ? date( "Y-m-d" , $dateVal["entered_at"] ) : "" );
					
					 $graphDataVals1 .= (!empty($userVals[$userWeightKey][$dateValue]["weight"])  ? $userVals[$userWeightKey][$dateValue]["weight"] : 0 ) . ",";
				}
				
				$graphDataVals1 = rtrim( $graphDataVals1 ,  ",");
				
				
				$graphData .= '"data": [ ' . $graphDataVals1 . ' ]},';
			}
			
			$graphData = rtrim( $graphData ,  ",");
			
			$graphData .= ']';
			
			$graphDates = rtrim( $graphDates ,  ",");
			
			$graph = array();
			$graph[0] = '[' . $graphDates . ']';
			$graph[1] = $graphData;
			
			return $graph;
			
			//print_r($userVals);
    }
	
	function getDatesListOnDemVal($fromDate , $toDate , $defaultValue = "")
	{
		
		$dateMonthYearArr = array();
		$fromDateTS = strtotime($fromDate);
		$toDateTS = strtotime($toDate);
		
		if($defaultValue == "")
		{
			$defaultValue = 518400;
		}
		
		for ($currentDateTS = $fromDateTS; $currentDateTS <= $toDateTS; $currentDateTS += ($defaultValue))
		{
			$currentDateStr = date("Y-m-d",$currentDateTS);
			$dateMonthYearArr[] = $currentDateStr;
		}

		return $dateMonthYearArr;
	}
	
	function getExerciseGraphData( $whereCond = "" ) {
		
		$userVals = array();
		$userVals1 = array();
		$datesVals = array();
		
		$dataQry = " SELECT 
						excercise_assessment.*
					FROM
					  	excercise_assessment
					WHERE activity_type <> '' AND !ISNULL(activity_type) 	
					 GROUP BY (excercise_assessment.activity_type)
					";

		$dataQry = " 
					SELECT
					  user_info.user_first_name,
					  user_info.user_last_name , excercise_assessment.*
					FROM
					  excercise_assessment
					  INNER JOIN user_info ON (excercise_assessment.user_id = user_info.id)
					WHERE $whereCond  AND activity_type <> '' AND !ISNULL(activity_type)
					  GROUP BY (excercise_assessment.activity_type)
					";
		
		$dataQry1 = $this->db->query($dataQry);
		$graphActivitiesData = $dataQry1->result_array();
		
		//print_r($graphActivitiesData);
		//exit;
		

		$graphUsersQry = " 
					SELECT 
					  user_info.user_first_name,
					  user_info.user_last_name , excercise_assessment.user_id , excercise_assessment.duration
					FROM
					  excercise_assessment
					  INNER JOIN user_info ON (excercise_assessment.user_id = user_info.id)
					WHERE $whereCond 
					  GROUP BY user_info.id
					";
		
		$graphUsersQry1 = $this->db->query($graphUsersQry);
		$graphUsersData1 = $graphUsersQry1->result_array();
		
		$graphDates = "";
		
		foreach( $graphUsersData1 as $graphUserKey => $graphUserVal )
		{
			$firstName = ucfirst(preg_replace('/\s+/', '', base64_url_decode($graphUserVal["user_first_name"])));
			$lastName = ucfirst(preg_replace('/\s+/', '', base64_url_decode($graphUserVal["user_last_name"])));
			
			$user = $firstName . "-" . $lastName;
		
			$graphDates .=  '"",';
		}

		$usersQry = " SELECT 
					  user_info.user_first_name,
					  user_info.user_last_name , excercise_assessment.*
					FROM
					  excercise_assessment
					  INNER JOIN user_info ON (excercise_assessment.user_id = user_info.id)
					 WHERE $whereCond
					";
		//WHERE $whereCond		
		$usersQry1 = $this->db->query($usersQry);
		$graphData1 = $usersQry1->result_array();
		
		foreach( $graphData1 as $graphDataKey => $graphDataVals )
		{
			$weightDate = $graphDataVals["activity_type"];
			
			$firstName = ucfirst(preg_replace('/\s+/', '', base64_url_decode($graphDataVals["user_first_name"])));
			$lastName = ucfirst(preg_replace('/\s+/', '', base64_url_decode($graphDataVals["user_last_name"])));
			
			$user = $firstName . "-" . $lastName;
			
			$userVals1[$graphDataVals["user_id"]] = $user;
			
			$duration = (!empty($graphDataVals["duration"]) ? floor($graphDataVals["duration"] / 60) : "0" );
			
			$userVals[$weightDate][$graphDataVals["user_id"]] = array( "user" => $user  , "weight" => $duration);
		}
		
			$graphData = '[';
			
			foreach( $graphActivitiesData as $userWeightKey => $userWeightVals )
			{
				//$user = $userVals1[$userWeightKey];
				
				$graphData .= '{ "name" : "' . $userWeightVals["activity_type"] . '" , ';
				 
				$graphDataVals1 = "";
				 
				foreach( $userVals1 as $dateKey => $dateVal )
				{
					 $graphDataVals1 .= (!empty($userVals[$userWeightVals["activity_type"]][$dateKey]["weight"])  ? $userVals[$userWeightVals["activity_type"]][$dateKey]["weight"] : 0 ) . ",";
				}
				
				$graphDataVals1 = rtrim( $graphDataVals1 ,  ",");
				
				$graphData .= '"data": [ ' . $graphDataVals1 . ' ]},';
			}
			
			$graphData = rtrim( $graphData ,  ",");
			
			$graphData .= ']';
			
			$graphDates = rtrim( $graphDates ,  ",");
			
			$graph = array();
			$graph[0] = '[' . $graphDates . ']';
			$graph[1] = $graphData;
			
			return $graph;
			
			//print_r($userVals);
    }
	
	function getHabitsData( $whereCond = "" ) {
	
		$dataVals = array();
		$habitsVals = array();
		
		$dataQry = " SELECT habit.* FROM habit WHERE $whereCond	";
		
		$dataQry1 = $this->db->query($dataQry);
		$dataVals = $dataQry1->result_array();
		
		foreach( $dataVals as $dataKey => $dataVal )
		{
			$habitsVals[$dataVal["user_id"]][$dataVal["habit_type"]] = array( "habit_data" => $dataVal["habit_data"] , 
			"habit_time" => (!empty($dataVal["habit_time"]) ? $dataVal["habit_time"] : "") , "updated_at" => $dataVal["updated_at"] );
		}
		
		return $habitsVals;
	}
	
	function getDietGraphData( $whereCond = "" ,  $whereCond1 = "") {
		
		$goalsQry = " SELECT goal.* FROM goal WHERE $whereCond1 ";
		
		$goalsQry1 = $this->db->query($goalsQry);
		$goalsData = $goalsQry1->result_array();
		
		/*$goalsVals = array();
				
		foreach( $goalsData as $goalKey => $goalVal )
		{
			$goalsVals[$goalVal["goal_type"]] = $goalVal["goal_data"];
		}*/

		$dataQry = " 
					SELECT diet_assessment.* , SUM(calories) AS totalCount
					FROM
					  diet_assessment
					
					WHERE $whereCond  AND diet_time <> '' AND !ISNULL(diet_time)
					  GROUP BY (diet_assessment.diet_time)
					";
		
		$dataQry1 = $this->db->query($dataQry);
		$graphActivitiesData = $dataQry1->result_array();
		
			$graphData = '[';
			
			$total = 0;
			
			foreach( $graphActivitiesData as $userWeightKey => $userWeightVals )
			{
				$graphData .= '{"name" : "' . $userWeightVals["diet_time"] . '",';
				$graphData .= ' "y" : ' . $userWeightVals["totalCount"] . '},';
				
				$total += $userWeightVals["totalCount"];
			}
			
			$graphData = rtrim( $graphData ,  ",");
			
			$graphData .= ']';
			
			$graph = array();
			$graph[0] = $graphData;
			$graph[1] = $goalsData;
			$graph[2] = $total;
			
			return $graph;
			//print_r($userVals);
    }
}
?>